#!/bin/csh -f

#-------------------------------------------------------
# amanda alexander 7/10/95
# spoelstr jacob. 5/95
# This script reads in the list of files in a directory
# and attemps to replace every occurance of a particular word in them 
# with another word that you provide.
# The script will only operate on text and script files.
#
# changewordinfiles.csh oldword newword  "file_spec"
#
# a popular usage is:
# changewordinfiles.csh bob sue "*"
#
#
# NOTE: this routine has a bug in that it does not
# preserve the file mode.  It sets the new file to
# whatever the umask is set to.
#-------------------------------------------------------

switch ($#argv)
case 0:
case 1:
case 2:
	echo ""
        echo "usage: changewordinfiles.csh oldword newword "\""file_spec"\"" "
	echo ""
	echo "Do not forget the quotes around the file name(s)."
        exit
endsw

set ztmp = z.z.z.tmp
foreach fn (`ls $3`)
# if not a link, then convert the file
	set whatkind = `file $fn`
	echo $whatkind
	echo $whatkind > $ztmp
	if ((`grep \-l "text" $ztmp` ==  $ztmp)||\
	(`grep \-l "script" $ztmp` ==  $ztmp)) then
		echo $fn
		cat $fn | sed s/$1/$2/ > _tmp_
		mv _tmp_ $fn
	endif
	rm $ztmp
end

echo ""
echo "BYE"



















