
# line 2 "aslcyacc.y"

//  ASL COMPILER
//
//  ASL (Abstract Schema Language) to c++ compiler
//
//
//
//  FILE NAME   : aslcyacc.y
//  MODULE TYPE : Yacc input specification
//  STATUS      : In development
//  PURPOSE     : Yacc source to generate ASL parser
//  
//
//  Instituto Tecnologico Autonomo de Mexico 
//  (c) Copyrigth 1995-1997 
//
//
//
//  HISTORY : Version (Date-Name) Modification, description. 
//
//            0.00  (Apr 20, 1992 - Longguang Wu), 
//            Start of development.
//
//            0.50  (May 05, 1993 - Roger Zimmermann),
//            Version 0.5 alpha.     
//
//            1.00  (Dec 17, 1995 - Claudia Calderas & Salvador Marmol), 
//            Compiler reconstruction, sintax extended.
//
//	      1.05  (Oct 09, 1997 - Oscar Peguero),
//	      Sintax according to the NSLC 3.0 specifications.
//
//	      1.10  (Feb 16, 1998 - Sebastian Gutierrez),
//	      Sintax extended according to the NSLC 3.0 specifications.
// 

#include "aslc.h"

void yyerror(char* s)
{
	/* compiler.sintaxError(s); */
}


# line 49 "aslcyacc.y"
typedef union
#ifdef __cplusplus
	YYSTYPE
#endif

{
   char  name[STR_LEN_LINE];     // String constants and identifiers.
} YYSTYPE;
# define CONST_CHAR 257
# define CONST_INT 258
# define CONST_FLOAT 259
# define CONST_STRING 260
# define INT 261
# define CHAR 262
# define DOUBLE 263
# define FLOAT 264
# define VOID 265
# define SHORT 266
# define LONG 267
# define SIGNED 268
# define UNSIGNED 269
# define NSLDINDOUBLE 270
# define NSLDINDOUBLE1 271
# define NSLDINDOUBLE2 272
# define NSLDINDOUBLE3 273
# define NSLDINDOUBLE4 274
# define NSLDINFLOAT 275
# define NSLDINFLOAT1 276
# define NSLDINFLOAT2 277
# define NSLDINFLOAT3 278
# define NSLDINFLOAT4 279
# define NSLDININT 280
# define NSLDININT1 281
# define NSLDININT2 282
# define NSLDININT3 283
# define NSLDININT4 284
# define NSLDOUTDOUBLE 285
# define NSLDOUTDOUBLE1 286
# define NSLDOUTDOUBLE2 287
# define NSLDOUTDOUBLE3 288
# define NSLDOUTDOUBLE4 289
# define NSLDOUTFLOAT 290
# define NSLDOUTFLOAT1 291
# define NSLDOUTFLOAT2 292
# define NSLDOUTFLOAT3 293
# define NSLDOUTFLOAT4 294
# define NSLDOUTINT 295
# define NSLDOUTINT1 296
# define NSLDOUTINT2 297
# define NSLDOUTINT3 298
# define NSLDOUTINT4 299
# define NSLDOUBLE 300
# define NSLDOUBLE0 301
# define NSLDOUBLE1 302
# define NSLDOUBLE2 303
# define NSLDOUBLE3 304
# define NSLDOUBLE4 305
# define NSLFLOAT 306
# define NSLFLOAT0 307
# define NSLFLOAT1 308
# define NSLFLOAT2 309
# define NSLFLOAT3 310
# define NSLFLOAT4 311
# define NSLINT 312
# define NSLINT0 313
# define NSLINT1 314
# define NSLINT2 315
# define NSLINT3 316
# define NSLINT4 317
# define NSLSTRING 318
# define SCHEMA_NAME 319
# define STRUCT_NAME 320
# define FUNCTION_NAME 321
# define PORT_NAME 322
# define IDENTIFIER_DECLARED 323
# define IDENTIFIER 324
# define AUTO 325
# define BREAK 326
# define CASE 327
# define CONST 328
# define CONTINUE 329
# define DEFAULT 330
# define DELETE 331
# define DO 332
# define ELSE 333
# define ENUM 334
# define EXTERN 335
# define FOR 336
# define IF 337
# define NEW 338
# define REGISTER 339
# define RETURN 340
# define SIZEOF 341
# define STATIC 342
# define SWITCH 343
# define VOLATILE 344
# define WHILE 345
# define MULT_EQUAL 346
# define DIV_EQUAL 347
# define MOD_EQUAL 348
# define PLUS_EQUAL 349
# define MINUS_EQUAL 350
# define SHIFT_RIGHT_EQUAL 351
# define SHIFT_LEFT_EQUAL 352
# define AND_EQUAL 353
# define XOR_EQUAL 354
# define OR_EQUAL 355
# define OR_LOGIC 356
# define AND_LOGIC 357
# define EQUAL 358
# define NOT_EQUAL 359
# define SHIFT_LEFT 360
# define SHIFT_RIGHT 361
# define LOWER_EQUAL 362
# define GREATER_EQUAL 363
# define PLUS_PLUS 364
# define MINUS_MINUS 365
# define INDIRECTION_1 366
# define INDIRECTION_2 367
# define INDIRECTION_3 368
# define DELEGATE 369
# define EXTERNAL 370
# define INHERIT 371
# define INTERNAL 372
# define INPUT 373
# define OUTPUT 374
# define SCHEMA 375
# define SELF 376
# define SIN 377
# define SOUT 378
# define STOP 379
# define THIS 380
# define OP_CONNECT_LR 381
# define OP_CONNECT_RL 382
# define OP_DISCONNECT 383
# define OP_RELABEL 384
# define OP_DELABEL 385

#ifdef __STDC__
#include <stdlib.h>
#include <string.h>
#else
#include <malloc.h>
#include <memory.h>
#endif

#include <values.h>

#ifdef __cplusplus

#ifndef yyerror
	void yyerror(const char *);
#endif

#ifndef yylex
#ifdef __EXTERN_C__
	extern "C" { int yylex(void); }
#else
	int yylex(void);
#endif
#endif
	int yyparse(void);

#endif
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
YYSTYPE yylval;
YYSTYPE yyval;
typedef int yytabelem;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#if YYMAXDEPTH > 0
int yy_yys[YYMAXDEPTH], *yys = yy_yys;
YYSTYPE yy_yyv[YYMAXDEPTH], *yyv = yy_yyv;
#else	/* user does initial allocation */
int *yys;
YYSTYPE *yyv;
#endif
static int yymaxdepth = YYMAXDEPTH;
# define YYERRCODE 256

# line 928 "aslcyacc.y"

yytabelem yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
-1, 11,
	59, 2,
	-2, 12,
-1, 13,
	0, 9,
	-2, 0,
-1, 15,
	59, 6,
	-2, 12,
-1, 21,
	125, 30,
	-2, 0,
-1, 29,
	125, 30,
	-2, 0,
-1, 30,
	125, 30,
	-2, 0,
-1, 128,
	40, 117,
	-2, 126,
-1, 178,
	41, 162,
	-2, 283,
-1, 257,
	41, 162,
	-2, 283,
-1, 270,
	59, 312,
	-2, 0,
-1, 336,
	59, 312,
	-2, 0,
-1, 391,
	59, 312,
	-2, 0,
-1, 422,
	59, 312,
	-2, 0,
-1, 424,
	59, 312,
	-2, 0,
-1, 448,
	59, 312,
	-2, 0,
-1, 449,
	59, 312,
	-2, 0,
-1, 450,
	59, 312,
	-2, 0,
-1, 473,
	59, 312,
	-2, 0,
-1, 481,
	59, 312,
	-2, 0,
	};
# define YYNPROD 321
# define YYLAST 3364
yytabelem yyact[]={

   177,   163,   186,   344,   211,   347,   307,   281,     8,   188,
   341,   270,   404,   322,     8,   106,   187,   135,   241,   242,
   230,   320,   231,   253,   146,    32,   234,   235,   228,   229,
   111,    41,   224,    32,    32,   222,    41,   428,    40,    41,
    41,   473,    41,    40,   388,   413,    40,    40,   120,    40,
   118,    31,   119,   309,   142,   472,    47,    43,    44,    45,
    54,    52,    48,    51,    53,    55,    56,    57,    58,    59,
    60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
    70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
    80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
    90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
   100,   101,   102,    49,   103,   151,   444,   461,    33,   414,
    36,    41,     6,    42,     7,    35,   220,     3,    40,   248,
    39,   152,   245,    10,    37,   362,   361,    38,   164,   264,
    16,   111,   173,    12,   265,    15,   209,    41,    11,   417,
   117,   126,   164,   170,    40,   172,   356,   357,   358,   359,
   360,   171,   127,   107,   221,     6,   476,     7,    46,    50,
   164,   243,   167,   149,   438,   169,   482,   168,   460,   122,
   247,   252,   254,   225,   256,   158,    14,   174,    41,   134,
   113,   132,   132,   175,   166,    40,   226,   114,   314,   267,
   156,   351,   120,   214,   118,    41,   119,   435,   208,   145,
   266,   144,    40,   268,   161,   458,   164,   432,   351,   164,
   480,   351,   130,   282,   273,   468,   212,   402,   434,   399,
   126,   398,   431,   430,   318,   352,   451,   269,   144,   144,
   203,   202,   204,   205,   144,   282,   155,   477,   282,   282,
   382,   104,    24,   144,    23,   439,    41,    19,   144,   422,
   391,   311,   312,    40,   157,   162,   236,    41,   237,   409,
   351,   282,   240,   282,    40,   350,   397,   238,   481,   436,
   346,   164,   239,   193,   385,   381,   474,   345,   190,   351,
   178,   227,   189,   191,   153,   192,   470,   303,   395,   384,
   138,   207,   462,   394,   246,   463,   200,   201,   141,   213,
   450,   154,   364,   351,   282,   449,   331,   448,   351,   386,
   351,   246,   232,   233,   215,   392,   445,   317,   223,   137,
   390,   316,   442,   116,   140,   441,   164,   282,   132,   132,
   440,   282,   420,   441,   383,   409,   346,   384,   136,   393,
   282,   137,   282,   345,    41,   410,   354,   353,   396,   198,
   412,    40,   120,   199,   282,   313,   119,   260,   218,    26,
   330,   326,   246,   332,   325,   447,   194,   294,   295,   305,
   271,   287,   324,   246,   343,   282,   290,   291,   292,   293,
   288,   289,   282,   111,   282,   282,   282,   284,   282,    41,
   415,   346,   286,   285,   424,   421,    40,   346,   345,   311,
   312,   429,   193,   423,   345,   323,    28,   190,   283,   178,
   131,   189,   191,   282,   192,   282,   321,    25,     1,   310,
   282,   416,   346,    13,   346,   282,   282,   244,   282,   345,
   452,   345,   456,   197,   446,   453,   123,   124,    27,   282,
   282,   282,   282,   250,   251,   249,   282,   185,   346,   346,
   346,   469,   133,   126,   184,   345,   345,   345,   182,   282,
   464,   465,   466,   179,   282,   300,   478,   299,   298,   475,
   483,   297,   282,   346,   375,   376,   164,   116,   129,   280,
   345,   346,   377,   378,   379,   479,   132,   132,   345,   296,
   165,   363,   332,   484,   319,   194,   327,   203,   202,   204,
   205,    47,    43,    44,    45,    54,    52,    48,    51,    53,
    55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
    65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
    75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
    85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
    95,    96,    97,    98,    99,   100,   101,   102,    49,   103,
   443,   355,   279,   200,   201,    36,   338,   328,    42,   339,
   329,   196,   336,   276,   275,    39,   337,   333,   195,    37,
   340,   183,    38,   334,   437,   335,   433,   365,   366,   367,
   368,   369,   370,   371,   372,   373,   374,   274,   258,   259,
   403,     2,   342,     9,   180,   181,    30,     4,   110,   278,
   109,     4,   176,    46,    50,     9,   198,   108,   150,   277,
   199,   471,   306,   219,   160,   327,   203,   202,   204,   205,
    47,    43,    44,    45,    54,    52,    48,    51,    53,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
    76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
    86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
    96,    97,    98,    99,   100,   101,   102,    49,   103,   457,
   408,   279,   200,   201,    36,   338,   328,    42,   339,   329,
   196,   336,   272,   112,    39,   337,   333,   195,    37,   340,
   183,    38,   334,   193,   335,   400,   159,   217,   190,   216,
   178,   125,   189,   191,   304,   192,    29,   389,   308,   315,
   263,   206,   121,   180,   181,    20,   128,   105,   278,    18,
    21,     5,    46,    50,    22,   198,    17,    34,   277,   199,
     0,     0,   348,     0,     0,     0,   406,   407,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   425,   426,
   427,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   348,     0,   255,     0,     0,     0,     0,
     0,     0,     0,   332,     0,     0,   194,     0,     0,   261,
     0,     0,     0,   139,     0,   143,     0,     0,     0,     0,
     0,   147,   148,     0,     0,     0,   467,     0,     0,   348,
     0,   411,     0,     0,     0,     0,     0,   193,     0,     0,
     0,     0,   190,   418,   178,     0,   189,   191,     0,   192,
   128,     0,     0,     0,   301,   302,     0,     0,     0,     0,
     0,     0,     0,     0,   419,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   454,   308,   380,   459,     0,     0,
     0,   128,     0,     0,     0,     0,     0,   387,     0,     0,
   194,     0,     0,     0,     0,   348,   327,   203,   202,   204,
   205,    47,    43,    44,    45,    54,    52,    48,    51,    53,
    55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
    65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
    75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
    85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
    95,    96,    97,    98,    99,   100,   101,   102,    49,   103,
     0,     0,   279,   200,   201,    36,   338,   328,    42,   339,
   329,   196,   336,     0,     0,    39,   337,   333,   195,    37,
   340,   183,    38,   334,     0,   335,     0,     0,     0,     0,
     0,   193,     0,     0,     0,     0,   190,     0,   178,     0,
   189,   191,     0,   192,   180,   181,     0,     0,   405,   278,
     0,     0,     0,    46,    50,     0,   198,   401,     0,   277,
   199,   203,   202,   204,   205,    47,    43,    44,    45,    54,
    52,    48,    51,    53,    55,    56,    57,    58,    59,    60,
    61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
    71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
    81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
    91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
   101,   102,    49,   103,   194,     0,   279,   200,   201,    36,
     0,     0,    42,     0,     0,   196,   405,     0,     0,    39,
     0,     0,   195,    37,     0,   183,    38,     0,     0,     0,
     0,     0,     0,     0,     0,   193,     0,     0,     0,     0,
   190,     0,   178,     0,   189,   191,     0,   192,   180,   181,
     0,     0,     0,   278,     0,     0,     0,    46,    50,     0,
   198,     0,     0,   277,   199,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   194,     0,
     0,     0,     0,     0,     0,   203,   202,   204,   205,    47,
    43,    44,    45,    54,    52,    48,    51,    53,    55,    56,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
    77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
    87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
    97,    98,    99,   100,   101,   102,    49,   103,     0,     0,
   279,   200,   201,     0,     0,     0,     0,     0,     0,   196,
     0,     0,     0,     0,     0,     0,   195,     0,     0,   183,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   180,   181,     0,     0,     0,   278,     0,     0,
     0,    46,    50,     0,   198,     0,     0,   277,   199,   203,
   202,   204,   205,    47,    43,    44,    45,    54,    52,    48,
    51,    53,    55,    56,    57,    58,    59,    60,    61,    62,
    63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
    73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
    83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
    93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
    49,   103,   193,     0,   279,   200,   201,   190,     0,   178,
     0,   189,   191,   196,   192,     0,     0,     0,     0,     0,
   195,     0,     0,   183,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   180,   181,     0,     0,
     0,   278,     0,     0,     0,    46,    50,     0,   198,     0,
     0,   277,   199,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   349,     0,     0,   194,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   193,     0,     0,     0,
     0,   190,     0,   178,     0,   189,   191,     0,   192,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   455,     0,     0,   194,
     0,     0,     0,     0,     0,     0,   203,   202,   204,   205,
    47,    43,    44,    45,    54,    52,    48,    51,    53,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
    76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
    86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
    96,    97,    98,    99,   100,   101,   102,    49,   103,     0,
     0,     0,   200,   201,     0,     0,     0,     0,     0,     0,
   196,     0,     0,     0,     0,     0,     0,   195,     0,     0,
   183,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   180,   181,     0,     0,     0,     0,     0,
     0,     0,    46,    50,     0,   198,     0,     0,     0,   199,
   203,   202,   204,   205,    47,    43,    44,    45,    54,    52,
    48,    51,    53,    55,    56,    57,    58,    59,    60,    61,
    62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
    72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
    82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
    92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
   102,    49,   103,   193,     0,     0,   200,   201,   190,     0,
   178,     0,   189,   191,   196,   192,     0,     0,     0,     0,
     0,   195,     0,     0,   183,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   180,   181,     0,
     0,     0,     0,     0,     0,     0,    46,    50,     0,   198,
     0,   262,     0,   199,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   194,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   193,     0,     0,
     0,     0,   190,     0,   178,     0,   189,   191,     0,   192,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   210,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   194,     0,     0,     0,     0,     0,     0,   203,   202,   204,
   205,    47,    43,    44,    45,    54,    52,    48,    51,    53,
    55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
    65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
    75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
    85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
    95,    96,    97,    98,    99,   100,   101,   102,    49,   103,
     0,     0,     0,   200,   201,     0,     0,     0,     0,     0,
     0,   196,     0,     0,     0,     0,     0,     0,   195,     0,
     0,   183,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   193,     0,     0,     0,     0,   190,     0,   178,     0,
   189,   191,     0,   192,   180,   181,     0,     0,     0,     0,
     0,     0,     0,    46,    50,     0,   198,     0,     0,     0,
   199,   203,   202,   204,   205,    47,    43,    44,    45,    54,
    52,    48,    51,    53,    55,    56,    57,    58,    59,    60,
    61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
    71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
    81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
    91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
   101,   102,    49,   103,   194,     0,     0,   200,   201,     0,
     0,     0,     0,     0,     0,   196,     0,     0,     0,     0,
     0,     0,   195,     0,     0,   183,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   193,     0,     0,     0,     0,
   190,     0,   257,     0,   189,   191,     0,   192,   180,   181,
     0,     0,     0,     0,     0,     0,     0,    46,    50,     0,
   198,     0,     0,     0,   199,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   194,     0,
     0,     0,     0,     0,     0,   203,   202,   204,   205,    47,
    43,    44,    45,    54,    52,    48,    51,    53,    55,    56,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
    77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
    87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
    97,    98,    99,   100,   101,   102,    49,   103,     0,     0,
     0,   200,   201,     0,     0,     0,     0,     0,     0,   196,
     0,     0,     0,     0,     0,     0,   195,     0,     0,   183,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   193,
     0,     0,     0,     0,   190,     0,   253,     0,   189,   191,
     0,   192,   180,   181,     0,     0,     0,     0,     0,     0,
     0,    46,    50,     0,   198,     0,     0,     0,   199,   203,
   202,   204,   205,    47,    43,    44,    45,    54,    52,    48,
    51,    53,    55,    56,    57,    58,    59,    60,    61,    62,
    63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
    73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
    83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
    93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
    49,   103,   194,     0,     0,   200,   201,     0,     0,     0,
     0,     0,     0,   196,     0,     0,     0,     0,     0,     0,
   195,     0,     0,   183,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   120,     0,   118,     0,   119,     0,
     0,     0,     0,     0,     0,     0,   180,   181,     0,     0,
     0,     0,     0,     0,   130,    46,    50,     0,   198,     0,
     0,     0,   199,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   203,   202,   204,   205,    47,    43,    44,
    45,    54,    52,    48,    51,    53,    55,    56,    57,    58,
    59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
    69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
    79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
    89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
    99,   100,   101,   102,    49,   103,     0,     0,     0,   200,
   201,   120,     0,   118,     0,   119,     0,   196,     0,     0,
     0,     0,     0,     0,   195,     0,     0,   183,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   180,   181,     0,     0,     0,     0,     0,     0,     0,    46,
    50,     0,   198,     0,     0,     0,   199,    47,    43,    44,
    45,    54,    52,    48,    51,    53,    55,    56,    57,    58,
    59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
    69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
    79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
    89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
    99,   100,   101,   102,    49,   103,     0,     0,     0,   116,
   129,    36,     0,   120,    42,   118,     0,   119,     0,     0,
     0,    39,     0,     0,     0,    37,     0,     0,    38,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    46,
    50,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    47,    43,    44,    45,    54,    52,
    48,    51,    53,    55,    56,    57,    58,    59,    60,    61,
    62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
    72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
    82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
    92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
   102,    49,   103,     0,     0,     0,   116,   115,    36,     0,
     0,    42,     0,     0,     0,     0,     0,     0,    39,     0,
     0,     0,    37,     0,     0,    38,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    46,    50,     0,     0,
     0,     0,     0,     0,     0,     0,    47,    43,    44,    45,
    54,    52,    48,    51,    53,    55,    56,    57,    58,    59,
    60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
    70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
    80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
    90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
   100,   101,   102,    49,   103,     0,     0,     0,   116,   140,
    36,     0,     0,    42,     0,     0,     0,     0,     0,     0,
    39,     0,     0,     0,    37,     0,     0,    38,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    46,    50,
    47,    43,    44,    45,    54,    52,    48,    51,    53,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
    76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
    86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
    96,    97,    98,    99,   100,   101,   102,    49,   103,     0,
     0,     0,     0,     0,     0,     0,     0,    42,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    46,    50 };
yytabelem yypact[]={

  -248,  -242,-10000000,  -176,  -248,    63,-10000000,-10000000,-10000000,-10000000,
  -179,-10000000,   198,  -242,-10000000,-10000000,   195,   193,   329,-10000000,
   329,  -205,   192,-10000000,-10000000,-10000000,  2753,-10000000,    54,  -205,
  -205,-10000000,  2586,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
   324,   324,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,  -354,   307,-10000000,-10000000,    10,
  -270,  2875,   148,-10000000,-10000000,  -342,-10000000,    10,    10,  -213,
  -213,  -354,   187,-10000000,-10000000,   141,-10000000,-10000000,   153,   207,
  2148,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,  2753,-10000000,   148,
-10000000,-10000000,  -342,   147,  1954,   181,   164,   120,   162,-10000000,
  -213,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,   328,
-10000000,  -132,  2148,-10000000,-10000000,   -28,  -325,    59,   102,   253,
  -330,   -40,  -334,   223,   235,  -349,-10000000,-10000000,  2989,    89,
  2466,  2466,  2148,  2272,-10000000,-10000000,-10000000,   324,   324,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,  2989,  1830,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,  -180,-10000000,  2148,   106,
-10000000,  2148,-10000000,   178,-10000000,-10000000,-10000000,   164,-10000000,   181,
-10000000,-10000000,  1132,  2148,  2148,  2148,  2148,  2148,  2148,  2148,
  2148,  2148,  2148,  2148,  2148,  2148,-10000000,-10000000,-10000000,-10000000,
-10000000,  2148,  2148,   256,  2148,-10000000,  2989,  1132,  2148,  -271,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,  2989,   -17,   -17,
   325,-10000000,   105,   287,-10000000,-10000000,-10000000,-10000000,   175,-10000000,
   379,-10000000,  1419,  2148,   177,-10000000,-10000000,   317,   316,  -225,
-10000000,-10000000,   251,  -325,    59,   102,   253,  -330,   -40,   -40,
  -334,  -334,  -334,  -334,   223,   223,  2148,  2148,  2148,  2148,
  2148,-10000000,-10000000,  2148,   244,-10000000,   157,   303,-10000000,-10000000,
   243,-10000000,-10000000,  1419,  2148,-10000000,  -280,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,  2148,   202,
-10000000,-10000000,-10000000,   309,   263,   258,   690,   236,   172,   170,
  1008,   168,-10000000,   226,  2875,   324,   324,   225,-10000000,  1419,
-10000000,  2148,  2148,  -200,  -200,   109,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,  2148,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,   235,   235,  -349,  -349,  -349,
-10000000,-10000000,-10000000,-10000000,  2148,-10000000,   301,-10000000,-10000000,  2753,
   201,   690,-10000000,  1132,  1132,  1132,  -308,   814,-10000000,-10000000,
   174,-10000000,-10000000,   173,-10000000,   167,   -17,   -17,   238,-10000000,
   130,-10000000,-10000000,   299,-10000000,   291,-10000000,  -206,-10000000,-10000000,
-10000000,   285,   690,-10000000,   250,   276,   274,   269,   196,  1132,
-10000000,-10000000,    10,-10000000,  1543,  2148,   154,  2148,    53,-10000000,
-10000000,  -202,-10000000,   261,-10000000,-10000000,-10000000,-10000000,   690,   690,
   690,  1132,   166,-10000000,-10000000,  1419,   255,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,  -267,  -292,-10000000,-10000000,   245,  1132,   122,
-10000000,   181,-10000000,   690,   161,   237,    51,-10000000,  2148,-10000000,
-10000000,   690,-10000000,-10000000,-10000000 };
yytabelem yypgo[]={

     0,   428,     3,   118,    16,     9,   757,   125,   420,   150,
   611,   756,   754,   616,   751,   750,   416,   749,   427,   747,
   189,   745,   742,    15,   741,   740,   739,   737,   736,   731,
   729,    11,   162,   727,   713,   726,   712,     5,   700,   699,
   634,     1,   633,     4,   631,   173,   628,   163,   627,   620,
   618,   190,   197,   171,   132,   612,   610,    12,   596,   489,
     6,   594,   384,   584,   583,    45,   571,   570,     7,     0,
   501,   500,   194,   172,   177,   175,   153,   161,   155,   142,
   187,   499,   481,   193,   478,   477,   475,   622,   473,   468,
   464,   457,     2,   443,   437,    21,   426,    13,   415,   382,
   374,   371,   370,    10,   325,   316 };
yytabelem yyr1[]={

     0,     1,    11,     1,     1,     1,    12,     1,     1,     1,
    15,    10,    17,    19,    14,    21,    22,    14,    14,    18,
    18,    20,    24,    20,    25,    25,    25,    26,    27,    26,
    16,    16,    16,    16,    13,    13,    28,    30,    28,     2,
     2,     3,     3,     6,     6,     6,     6,     8,     8,     7,
     7,     7,     4,     4,     4,     4,     4,     4,     4,     4,
     4,     4,     4,     4,     5,     5,     5,     5,     5,     5,
     5,     5,     5,     5,     5,     5,     5,     5,     5,     5,
     5,     5,     5,     5,     5,     5,     5,     5,     5,     5,
     5,     5,     5,     5,     5,     5,     5,     5,     5,     5,
     5,     5,     5,     5,     5,     5,     5,     5,     5,     5,
     5,     5,     5,    29,    29,    33,    29,    35,    36,    38,
    32,    32,    32,    32,    42,    32,    40,    40,    39,    44,
    39,    34,    34,    34,    34,    34,    34,     9,     9,    45,
    45,    46,    46,    47,    47,    47,    47,    48,    48,    48,
    48,    23,    23,    49,    49,    51,    43,    43,    50,    50,
    52,    53,    54,    54,    55,    56,    56,    57,    58,    58,
    58,    58,    58,    37,    37,    61,    37,    37,    37,    62,
    62,    63,    63,    63,    63,    66,    66,    66,    66,    66,
    66,    66,    67,    67,    65,    65,    64,    64,    59,    59,
    70,    70,    70,    70,    70,    70,    70,    70,    70,    70,
    70,    68,    68,    71,    71,    72,    72,    73,    73,    74,
    74,    75,    75,    76,    76,    76,    77,    77,    77,    77,
    77,    78,    78,    78,    79,    81,    79,    82,    79,    80,
    84,    80,    85,    80,    86,    80,    83,    83,    83,    87,
    87,    69,    69,    69,    69,    69,    69,    69,    69,    89,
    89,    89,    89,    89,    89,    90,    90,    91,    91,    88,
    88,    88,    88,    88,    88,    88,    88,    60,    60,    60,
    92,    92,    92,    94,    92,    92,    92,    93,    93,    93,
    93,    41,    95,    95,    95,    95,    95,    95,    95,    96,
    96,   102,   104,    98,    31,    31,    99,    99,    99,   100,
   100,   100,   103,   103,    97,    97,   101,   101,   101,   101,
   105 };
yytabelem yyr2[]={

     0,     3,     1,     9,     7,     5,     1,    11,     9,     4,
     1,    13,     1,     1,    13,     1,     1,    13,     3,     1,
     7,     1,     1,     9,     3,     3,     7,     0,     1,     9,
     0,     4,     4,     3,     3,     3,     7,     1,    12,     3,
     5,     3,     3,     3,     3,     3,     3,     1,     3,     5,
     5,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     0,     2,     1,     8,     1,     1,     1,
    16,     4,     6,     4,     1,    10,     0,     5,     0,     1,
     8,     3,     3,     4,     8,     6,     6,     5,     5,     0,
     4,     2,     2,     0,     3,     2,     2,     2,     4,     8,
     2,     2,     6,     2,     4,    10,     0,     3,     2,     4,
     8,     2,     0,     4,     6,     2,     6,     4,     0,     4,
    10,     8,     6,     0,     2,     1,     8,     8,     6,     2,
     2,     8,     8,     6,    10,     2,     2,     2,     2,     2,
     2,     2,     2,     6,     2,     6,     2,     6,     2,     6,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    10,     2,     6,     2,     6,     2,     6,     2,
     6,     2,     6,     2,     6,     6,     2,     6,     6,     6,
     6,     2,     6,     6,     2,     1,     8,     1,     8,     2,
     1,     8,     1,     8,     1,     8,     2,     6,     6,     2,
     8,     2,     4,     4,     4,     4,     8,     2,     2,     3,
     3,     3,     3,     3,     3,    10,     4,     4,     8,     2,
     8,     8,     6,     4,     4,     6,     6,     0,     2,     6,
     2,     3,     3,     1,     9,     3,     3,     3,     3,     3,
     3,     2,     2,     2,     2,     2,     2,     2,     2,     8,
     6,     4,     1,     9,     0,     4,    10,    14,    10,    10,
    14,    16,     0,     2,     2,     2,     4,     4,     6,     4,
     2 };
yytabelem yychk[]={

-10000000,    -1,   -10,   375,   -13,   -14,   370,   372,   256,   -10,
   375,   324,   319,    -1,   123,   324,   319,   -11,   -17,    59,
   -21,   -15,   -12,    59,    59,   -18,    40,   -18,   -16,   -28,
   -13,   256,    -2,    -3,    -6,    -7,   325,   339,   342,   335,
    -4,    -5,   328,   262,   263,   264,   373,   261,   267,   318,
   374,   268,   266,   269,   265,   270,   271,   272,   273,   274,
   275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
   285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
   295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
   305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
   315,   316,   317,   319,    59,   -19,   -23,   -47,   -48,   -49,
   -50,    -2,   -34,   -51,   -52,   324,   323,    -9,    40,    42,
    38,   -22,   125,   -16,   -16,   -29,    -3,   -32,   -34,   324,
    58,    -8,    -9,    -8,   -20,   371,    41,    44,   -51,   -34,
   324,   -52,   324,   -34,    91,    61,   366,   -34,   -34,   -45,
   -46,   328,   344,   -45,   -20,    59,    59,   123,    44,   -35,
   -40,    61,    58,   -41,   -68,   -71,   -72,   -73,   -74,   -75,
   -76,   -77,   -78,   -79,   -80,   -83,   -87,   -69,    40,   -88,
   364,   365,   -89,   341,   -90,   -91,   -92,    -4,    -5,    42,
    38,    43,    45,    33,   126,   338,   331,   -93,   376,   380,
   323,   324,   258,   257,   259,   260,   -24,   -47,    61,   -41,
    93,   -43,    45,   -32,    41,   -45,   -30,   -33,    40,   -42,
   258,   -41,    63,   356,   357,   124,    94,    38,   358,   359,
    60,    62,   362,   363,   360,   361,    43,    45,    42,    47,
    37,   367,   368,   -53,   -94,   -54,    -7,    91,    40,   366,
   364,   365,   -69,    40,   -69,   -87,   -69,    40,    -8,    -8,
   -53,   -87,    91,   -25,   319,   324,   -41,    93,   -41,    59,
   -31,   -32,   -36,   -43,   -62,   -63,   -64,   379,   369,   322,
   -59,   -68,   -69,   -72,   -73,   -74,   -75,   -76,   -77,   -77,
   -78,   -78,   -78,   -78,   -79,   -79,   -81,   -82,   -84,   -85,
   -86,   -87,   -87,    41,   -59,   -54,   -62,   -60,   -59,   324,
   -53,   -92,   -92,    40,    93,   -26,    44,    40,    59,   125,
   -95,   -96,   -97,   -98,   -99,  -100,  -101,   256,   327,   330,
  -102,  -105,   123,   337,   343,   345,   332,   336,   326,   329,
   340,  -103,   -55,   -62,    -2,    -4,    -5,   -37,   -59,   123,
   -41,    44,    58,    40,    40,   -66,   381,   382,   383,   384,
   385,   361,   360,   -70,    61,   346,   347,   348,   349,   350,
   351,   352,   353,   354,   355,   -80,   -80,   -83,   -83,   -83,
   -87,    41,    93,    41,    44,    41,   -37,   -87,   324,   -27,
   -41,    58,  -104,    40,    40,    40,   -95,    40,    59,    59,
   -62,    59,    59,   -56,   -57,   -34,    -8,    -8,   -38,    44,
   -37,   -59,   -68,   -65,   319,   -65,   322,    40,   -59,   -59,
    41,   -23,    58,   -95,   -31,   -62,   -62,   -62,   345,   -97,
    59,    59,    44,   -58,    61,    40,    41,   -61,    44,   125,
    41,    44,    41,   -67,   322,    41,   -95,   125,    41,    41,
    41,    40,  -103,   -57,   -59,   123,   -60,   -39,    61,   -59,
   125,   319,    41,    44,   -95,   -95,   -95,   -62,    59,   -37,
    41,   -44,   322,   333,    41,  -103,    44,   125,   -43,   -95,
    59,    41,   125,   -41,   -95 };
yytabelem yydef[]={

     0,    -2,     1,     0,     0,     0,    34,    35,    18,     5,
     0,    -2,    15,    -2,    10,    -2,    15,     0,    19,     4,
    19,    -2,     0,     8,     3,    13,   143,    16,     0,    -2,
    -2,    33,   113,    39,    41,    42,    43,    44,    45,    46,
    47,    47,    51,    52,    53,    54,    55,    56,    57,    58,
    59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
    69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
    79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
    89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
    99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
   109,   110,   111,   112,     7,    21,     0,   151,   144,   145,
   146,   147,   150,   153,   158,   131,   132,     0,     0,   139,
   139,    21,     0,    31,    32,     0,    40,   114,    -2,   131,
     0,    49,    48,    50,    14,    22,    20,   143,   154,     0,
   131,   159,     0,   148,     0,   156,     0,   133,     0,   137,
   139,   141,   142,   138,    17,    11,    36,    37,   115,     0,
   121,   124,     0,   123,   291,   211,   213,   215,   217,   219,
   221,   223,   226,   231,   234,   239,   246,   249,    -2,   251,
     0,     0,     0,     0,   257,   258,   269,    47,    47,   259,
   260,   261,   262,   263,   264,   162,     0,   280,   281,   282,
   285,   286,   287,   288,   289,   290,     0,   152,     0,     0,
   135,     0,   157,     0,   136,   140,   304,     0,   118,   156,
   127,   122,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   235,   237,   240,   242,
   244,     0,     0,     0,     0,   161,   162,     0,   277,     0,
   273,   274,   252,   283,   253,   254,   255,    -2,     0,     0,
   266,   267,     0,    27,    24,    25,   149,   134,     0,   160,
    -2,   116,   173,     0,     0,   179,   180,     0,     0,     0,
   196,   198,   249,   214,   216,   218,   220,   222,   224,   225,
   227,   228,   229,   230,   232,   233,     0,     0,     0,     0,
     0,   247,   248,     0,     0,   163,     0,     0,   278,   272,
     0,   275,   276,   173,     0,    23,     0,    28,   155,    38,
   305,   292,   293,   294,   295,   296,   297,   298,     0,     0,
   314,   315,   302,     0,     0,     0,    -2,     0,     0,     0,
     0,     0,   320,   313,     0,    47,    47,   119,   174,   173,
   125,     0,     0,     0,     0,     0,   185,   186,   187,   188,
   189,   190,   191,     0,   200,   201,   202,   203,   204,   205,
   206,   207,   208,   209,   210,   236,   238,   241,   243,   245,
   250,   284,   270,   271,     0,   256,     0,   268,    26,   143,
     0,    -2,   304,     0,     0,     0,     0,   312,   316,   317,
     0,   319,   301,     0,   165,   168,    49,    50,     0,   175,
     0,   197,   212,     0,   194,     0,   183,     0,   199,   279,
   265,     0,    -2,   300,    -2,     0,     0,     0,     0,   312,
   318,   164,     0,   167,     0,   277,   128,     0,   175,   178,
   181,     0,   182,     0,   192,    29,   299,   303,    -2,    -2,
    -2,     0,     0,   166,   169,   173,     0,   120,   129,   176,
   177,   195,   184,     0,   306,   308,   309,     0,   312,     0,
   172,   156,   193,    -2,     0,     0,   175,   171,     0,   307,
   310,    -2,   170,   130,   311 };
typedef struct
#ifdef __cplusplus
	yytoktype
#endif
{ char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"CONST_CHAR",	257,
	"CONST_INT",	258,
	"CONST_FLOAT",	259,
	"CONST_STRING",	260,
	"INT",	261,
	"CHAR",	262,
	"DOUBLE",	263,
	"FLOAT",	264,
	"VOID",	265,
	"SHORT",	266,
	"LONG",	267,
	"SIGNED",	268,
	"UNSIGNED",	269,
	"NSLDINDOUBLE",	270,
	"NSLDINDOUBLE1",	271,
	"NSLDINDOUBLE2",	272,
	"NSLDINDOUBLE3",	273,
	"NSLDINDOUBLE4",	274,
	"NSLDINFLOAT",	275,
	"NSLDINFLOAT1",	276,
	"NSLDINFLOAT2",	277,
	"NSLDINFLOAT3",	278,
	"NSLDINFLOAT4",	279,
	"NSLDININT",	280,
	"NSLDININT1",	281,
	"NSLDININT2",	282,
	"NSLDININT3",	283,
	"NSLDININT4",	284,
	"NSLDOUTDOUBLE",	285,
	"NSLDOUTDOUBLE1",	286,
	"NSLDOUTDOUBLE2",	287,
	"NSLDOUTDOUBLE3",	288,
	"NSLDOUTDOUBLE4",	289,
	"NSLDOUTFLOAT",	290,
	"NSLDOUTFLOAT1",	291,
	"NSLDOUTFLOAT2",	292,
	"NSLDOUTFLOAT3",	293,
	"NSLDOUTFLOAT4",	294,
	"NSLDOUTINT",	295,
	"NSLDOUTINT1",	296,
	"NSLDOUTINT2",	297,
	"NSLDOUTINT3",	298,
	"NSLDOUTINT4",	299,
	"NSLDOUBLE",	300,
	"NSLDOUBLE0",	301,
	"NSLDOUBLE1",	302,
	"NSLDOUBLE2",	303,
	"NSLDOUBLE3",	304,
	"NSLDOUBLE4",	305,
	"NSLFLOAT",	306,
	"NSLFLOAT0",	307,
	"NSLFLOAT1",	308,
	"NSLFLOAT2",	309,
	"NSLFLOAT3",	310,
	"NSLFLOAT4",	311,
	"NSLINT",	312,
	"NSLINT0",	313,
	"NSLINT1",	314,
	"NSLINT2",	315,
	"NSLINT3",	316,
	"NSLINT4",	317,
	"NSLSTRING",	318,
	"SCHEMA_NAME",	319,
	"STRUCT_NAME",	320,
	"FUNCTION_NAME",	321,
	"PORT_NAME",	322,
	"IDENTIFIER_DECLARED",	323,
	"IDENTIFIER",	324,
	"AUTO",	325,
	"BREAK",	326,
	"CASE",	327,
	"CONST",	328,
	"CONTINUE",	329,
	"DEFAULT",	330,
	"DELETE",	331,
	"DO",	332,
	"ELSE",	333,
	"ENUM",	334,
	"EXTERN",	335,
	"FOR",	336,
	"IF",	337,
	"NEW",	338,
	"REGISTER",	339,
	"RETURN",	340,
	"SIZEOF",	341,
	"STATIC",	342,
	"SWITCH",	343,
	"VOLATILE",	344,
	"WHILE",	345,
	"MULT_EQUAL",	346,
	"DIV_EQUAL",	347,
	"MOD_EQUAL",	348,
	"PLUS_EQUAL",	349,
	"MINUS_EQUAL",	350,
	"SHIFT_RIGHT_EQUAL",	351,
	"SHIFT_LEFT_EQUAL",	352,
	"AND_EQUAL",	353,
	"XOR_EQUAL",	354,
	"OR_EQUAL",	355,
	"OR_LOGIC",	356,
	"AND_LOGIC",	357,
	"EQUAL",	358,
	"NOT_EQUAL",	359,
	"SHIFT_LEFT",	360,
	"SHIFT_RIGHT",	361,
	"LOWER_EQUAL",	362,
	"GREATER_EQUAL",	363,
	"PLUS_PLUS",	364,
	"MINUS_MINUS",	365,
	"INDIRECTION_1",	366,
	"INDIRECTION_2",	367,
	"INDIRECTION_3",	368,
	"DELEGATE",	369,
	"EXTERNAL",	370,
	"INHERIT",	371,
	"INTERNAL",	372,
	"INPUT",	373,
	"OUTPUT",	374,
	"SCHEMA",	375,
	"SELF",	376,
	"SIN",	377,
	"SOUT",	378,
	"STOP",	379,
	"THIS",	380,
	"OP_CONNECT_LR",	381,
	"OP_CONNECT_RL",	382,
	"OP_DISCONNECT",	383,
	"OP_RELABEL",	384,
	"OP_DELABEL",	385,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"schema : schemaSpecifier",
	"schema : SCHEMA IDENTIFIER",
	"schema : SCHEMA IDENTIFIER ';'",
	"schema : SCHEMA SCHEMA_NAME ';'",
	"schema : schema schemaSpecifier",
	"schema : schema SCHEMA IDENTIFIER",
	"schema : schema SCHEMA IDENTIFIER ';'",
	"schema : schema SCHEMA SCHEMA_NAME ';'",
	"schema : accessSpecifier schema",
	"schemaSpecifier : schemaHeader '{'",
	"schemaSpecifier : schemaHeader '{' memberList '}' ';'",
	"schemaHeader : SCHEMA IDENTIFIER",
	"schemaHeader : SCHEMA IDENTIFIER construct_args",
	"schemaHeader : SCHEMA IDENTIFIER construct_args baseSpecifier",
	"schemaHeader : SCHEMA SCHEMA_NAME",
	"schemaHeader : SCHEMA SCHEMA_NAME construct_args",
	"schemaHeader : SCHEMA SCHEMA_NAME construct_args baseSpecifier",
	"schemaHeader : error",
	"construct_args : /* empty */",
	"construct_args : '(' argumentList ')'",
	"baseSpecifier : /* empty */",
	"baseSpecifier : INHERIT",
	"baseSpecifier : INHERIT baseList extendsArgs",
	"baseList : SCHEMA_NAME",
	"baseList : IDENTIFIER",
	"baseList : baseList ',' IDENTIFIER",
	"extendsArgs : /* empty */",
	"extendsArgs : '('",
	"extendsArgs : '(' argumentList ')'",
	"memberList : /* empty */",
	"memberList : memberDeclaration memberList",
	"memberList : accessSpecifier memberList",
	"memberList : error",
	"accessSpecifier : EXTERNAL",
	"accessSpecifier : INTERNAL",
	"memberDeclaration : declSpecifierList declMemberList ';'",
	"memberDeclaration : declSpecifierList declMemberList '{'",
	"memberDeclaration : declSpecifierList declMemberList '{' statementList '}'",
	"declSpecifierList : declSpecifier",
	"declSpecifierList : declSpecifierList declSpecifier",
	"declSpecifier : classStorageSpecifier",
	"declSpecifier : typeSpecifier",
	"classStorageSpecifier : AUTO",
	"classStorageSpecifier : REGISTER",
	"classStorageSpecifier : STATIC",
	"classStorageSpecifier : EXTERN",
	"accessOption : /* empty */",
	"accessOption : pointerOperator",
	"typeSpecifier : simpleTypeName accessOption",
	"typeSpecifier : nslTypeName accessOption",
	"typeSpecifier : CONST",
	"simpleTypeName : CHAR",
	"simpleTypeName : DOUBLE",
	"simpleTypeName : FLOAT",
	"simpleTypeName : INPUT",
	"simpleTypeName : INT",
	"simpleTypeName : LONG",
	"simpleTypeName : NSLSTRING",
	"simpleTypeName : OUTPUT",
	"simpleTypeName : SIGNED",
	"simpleTypeName : SHORT",
	"simpleTypeName : UNSIGNED",
	"simpleTypeName : VOID",
	"nslTypeName : NSLDINDOUBLE",
	"nslTypeName : NSLDINDOUBLE1",
	"nslTypeName : NSLDINDOUBLE2",
	"nslTypeName : NSLDINDOUBLE3",
	"nslTypeName : NSLDINDOUBLE4",
	"nslTypeName : NSLDINFLOAT",
	"nslTypeName : NSLDINFLOAT1",
	"nslTypeName : NSLDINFLOAT2",
	"nslTypeName : NSLDINFLOAT3",
	"nslTypeName : NSLDINFLOAT4",
	"nslTypeName : NSLDININT",
	"nslTypeName : NSLDININT1",
	"nslTypeName : NSLDININT2",
	"nslTypeName : NSLDININT3",
	"nslTypeName : NSLDININT4",
	"nslTypeName : NSLDOUTDOUBLE",
	"nslTypeName : NSLDOUTDOUBLE1",
	"nslTypeName : NSLDOUTDOUBLE2",
	"nslTypeName : NSLDOUTDOUBLE3",
	"nslTypeName : NSLDOUTDOUBLE4",
	"nslTypeName : NSLDOUTFLOAT",
	"nslTypeName : NSLDOUTFLOAT1",
	"nslTypeName : NSLDOUTFLOAT2",
	"nslTypeName : NSLDOUTFLOAT3",
	"nslTypeName : NSLDOUTFLOAT4",
	"nslTypeName : NSLDOUTINT",
	"nslTypeName : NSLDOUTINT1",
	"nslTypeName : NSLDOUTINT2",
	"nslTypeName : NSLDOUTINT3",
	"nslTypeName : NSLDOUTINT4",
	"nslTypeName : NSLDOUBLE",
	"nslTypeName : NSLDOUBLE0",
	"nslTypeName : NSLDOUBLE1",
	"nslTypeName : NSLDOUBLE2",
	"nslTypeName : NSLDOUBLE3",
	"nslTypeName : NSLDOUBLE4",
	"nslTypeName : NSLFLOAT",
	"nslTypeName : NSLFLOAT0",
	"nslTypeName : NSLFLOAT1",
	"nslTypeName : NSLFLOAT2",
	"nslTypeName : NSLFLOAT3",
	"nslTypeName : NSLFLOAT4",
	"nslTypeName : NSLINT",
	"nslTypeName : NSLINT0",
	"nslTypeName : NSLINT1",
	"nslTypeName : NSLINT2",
	"nslTypeName : NSLINT3",
	"nslTypeName : NSLINT4",
	"nslTypeName : SCHEMA_NAME",
	"declMemberList : /* empty */",
	"declMemberList : memberDecl",
	"declMemberList : declMemberList ','",
	"declMemberList : declMemberList ',' memberDecl",
	"memberDecl : declarator",
	"memberDecl : declarator '('",
	"memberDecl : declarator '(' initializerList",
	"memberDecl : declarator '(' initializerList ')' myInit",
	"memberDecl : declarator pureSpecifier",
	"memberDecl : IDENTIFIER ':' constantExpression",
	"memberDecl : ':' constantExpression",
	"memberDecl : declarator '='",
	"memberDecl : declarator '=' constNeg constantExpression",
	"pureSpecifier : /* empty */",
	"pureSpecifier : '=' CONST_INT",
	"myInit : /* empty */",
	"myInit : '='",
	"myInit : '=' constNeg constantExpression",
	"declarator : IDENTIFIER",
	"declarator : IDENTIFIER_DECLARED",
	"declarator : pointerOperator declarator",
	"declarator : declarator '[' constantExpression ']'",
	"declarator : declarator '[' ']'",
	"declarator : '(' declarator ')'",
	"pointerOperator : '*' cvQualifierList",
	"pointerOperator : '&' cvQualifierList",
	"cvQualifierList : /* empty */",
	"cvQualifierList : cvQualifier cvQualifierList",
	"cvQualifier : CONST",
	"cvQualifier : VOLATILE",
	"argument : /* empty */",
	"argument : argsDef",
	"argument : objectInitList",
	"argument : objectMethodsInvList",
	"argsDef : declSpecifierList",
	"argsDef : declSpecifierList declarator",
	"argsDef : declSpecifierList declarator '=' constantExpression",
	"argsDef : declarator",
	"argumentList : argument",
	"argumentList : argumentList ',' argument",
	"objectInitList : objectInit",
	"objectInitList : objectInitList objectInit",
	"objectInit : declarator '=' constNeg constantExpression ';'",
	"constNeg : /* empty */",
	"constNeg : '-'",
	"objectMethodsInvList : objectMethodsInv",
	"objectMethodsInvList : objectMethodsInvList objectMethodsInv",
	"objectMethodsInv : IDENTIFIER INDIRECTION_1 memberDecl ';'",
	"typeName : typeSpecifierList",
	"typeSpecifierList : /* empty */",
	"typeSpecifierList : typeSpecifier typeSpecifierList",
	"declaration : declSpecifierList declaratorList ';'",
	"declaratorList : initDeclarator",
	"declaratorList : declaratorList ',' initDeclarator",
	"initDeclarator : declarator initializer",
	"initializer : /* empty */",
	"initializer : '=' assignExpression",
	"initializer : '=' '{' initializerList ',' '}'",
	"initializer : '=' '{' initializerList '}'",
	"initializer : '(' expressionList ')'",
	"initializerList : /* empty */",
	"initializerList : assignExpression",
	"initializerList : initializerList ','",
	"initializerList : initializerList ',' assignExpression",
	"initializerList : '{' initializerList ',' '}'",
	"initializerList : '{' initializerList '}'",
	"expression : portExpression",
	"expression : expressionIter",
	"portExpression : STOP '(' schemaList ')'",
	"portExpression : DELEGATE '(' schemaList ')'",
	"portExpression : PORT_NAME portOperator PORT_NAME",
	"portExpression : PORT_NAME portOperator '(' portList ')'",
	"portOperator : OP_CONNECT_LR",
	"portOperator : OP_CONNECT_RL",
	"portOperator : OP_DISCONNECT",
	"portOperator : OP_RELABEL",
	"portOperator : OP_DELABEL",
	"portOperator : SHIFT_RIGHT",
	"portOperator : SHIFT_LEFT",
	"portList : PORT_NAME",
	"portList : portList ',' PORT_NAME",
	"schemaList : SCHEMA_NAME",
	"schemaList : schemaList ',' SCHEMA_NAME",
	"expressionIter : assignExpression",
	"expressionIter : expression ',' assignExpression",
	"assignExpression : conditionalExpression",
	"assignExpression : unaryExpression assignOperator assignExpression",
	"assignOperator : '='",
	"assignOperator : MULT_EQUAL",
	"assignOperator : DIV_EQUAL",
	"assignOperator : MOD_EQUAL",
	"assignOperator : PLUS_EQUAL",
	"assignOperator : MINUS_EQUAL",
	"assignOperator : SHIFT_RIGHT_EQUAL",
	"assignOperator : SHIFT_LEFT_EQUAL",
	"assignOperator : AND_EQUAL",
	"assignOperator : XOR_EQUAL",
	"assignOperator : OR_EQUAL",
	"conditionalExpression : orLogicalExpression",
	"conditionalExpression : orLogicalExpression '?' expression ':' conditionalExpression",
	"orLogicalExpression : andLogicalExpression",
	"orLogicalExpression : orLogicalExpression OR_LOGIC andLogicalExpression",
	"andLogicalExpression : inOrExpression",
	"andLogicalExpression : andLogicalExpression AND_LOGIC inOrExpression",
	"inOrExpression : xorExpression",
	"inOrExpression : inOrExpression '|' xorExpression",
	"xorExpression : andExpression",
	"xorExpression : xorExpression '^' andExpression",
	"andExpression : equalExpression",
	"andExpression : andExpression '&' equalExpression",
	"equalExpression : relationalExpression",
	"equalExpression : equalExpression EQUAL relationalExpression",
	"equalExpression : equalExpression NOT_EQUAL relationalExpression",
	"relationalExpression : moveExpression",
	"relationalExpression : relationalExpression '<' moveExpression",
	"relationalExpression : relationalExpression '>' moveExpression",
	"relationalExpression : relationalExpression LOWER_EQUAL moveExpression",
	"relationalExpression : relationalExpression GREATER_EQUAL moveExpression",
	"moveExpression : aditiveExpression",
	"moveExpression : moveExpression SHIFT_LEFT aditiveExpression",
	"moveExpression : moveExpression SHIFT_RIGHT aditiveExpression",
	"aditiveExpression : prodExpression",
	"aditiveExpression : aditiveExpression '+'",
	"aditiveExpression : aditiveExpression '+' prodExpression",
	"aditiveExpression : aditiveExpression '-'",
	"aditiveExpression : aditiveExpression '-' prodExpression",
	"prodExpression : apmExpression",
	"prodExpression : prodExpression '*'",
	"prodExpression : prodExpression '*' apmExpression",
	"prodExpression : prodExpression '/'",
	"prodExpression : prodExpression '/' apmExpression",
	"prodExpression : prodExpression '",
	"prodExpression : prodExpression 'apmExpression",
	"apmExpression : mutationExpression",
	"apmExpression : apmExpression INDIRECTION_2 mutationExpression",
	"apmExpression : apmExpression INDIRECTION_3 mutationExpression",
	"mutationExpression : unaryExpression",
	"mutationExpression : '(' typeName ')' mutationExpression",
	"unaryExpression : postfixExpression",
	"unaryExpression : PLUS_PLUS unaryExpression",
	"unaryExpression : MINUS_MINUS unaryExpression",
	"unaryExpression : unaryOperator mutationExpression",
	"unaryExpression : SIZEOF unaryExpression",
	"unaryExpression : SIZEOF '(' typeName ')'",
	"unaryExpression : newExpression",
	"unaryExpression : deleteExpression",
	"unaryOperator : '*'",
	"unaryOperator : '&'",
	"unaryOperator : '+'",
	"unaryOperator : '-'",
	"unaryOperator : '!'",
	"unaryOperator : '~'",
	"newExpression : NEW typeName '(' initializerList ')'",
	"newExpression : NEW typeName",
	"deleteExpression : DELETE mutationExpression",
	"deleteExpression : DELETE '[' ']' mutationExpression",
	"postfixExpression : primaryExpression",
	"postfixExpression : postfixExpression '[' expression ']'",
	"postfixExpression : postfixExpression '(' expressionList ')'",
	"postfixExpression : postfixExpression INDIRECTION_1 IDENTIFIER",
	"postfixExpression : postfixExpression PLUS_PLUS",
	"postfixExpression : postfixExpression MINUS_MINUS",
	"postfixExpression : simpleTypeName accessOption primaryExpression",
	"postfixExpression : nslTypeName accessOption primaryExpression",
	"expressionList : /* empty */",
	"expressionList : assignExpression",
	"expressionList : expressionList ',' assignExpression",
	"primaryExpression : literal",
	"primaryExpression : SELF",
	"primaryExpression : THIS",
	"primaryExpression : '('",
	"primaryExpression : '(' assignExpression ')'",
	"primaryExpression : IDENTIFIER_DECLARED",
	"primaryExpression : IDENTIFIER",
	"literal : CONST_INT",
	"literal : CONST_CHAR",
	"literal : CONST_FLOAT",
	"literal : CONST_STRING",
	"constantExpression : conditionalExpression",
	"statement : labelStatement",
	"statement : initForStatement",
	"statement : complexStatement",
	"statement : selectStatement",
	"statement : iterationStatement",
	"statement : jumpStatement",
	"statement : error",
	"labelStatement : CASE constantExpression ':' statement",
	"labelStatement : DEFAULT ':' statement",
	"expressionStatement : optExpression ';'",
	"complexStatement : '{'",
	"complexStatement : '{' statementList '}'",
	"statementList : /* empty */",
	"statementList : statementList statement",
	"selectStatement : IF '(' expression ')' statement",
	"selectStatement : IF '(' expression ')' statement ELSE statement",
	"selectStatement : SWITCH '(' expression ')' statement",
	"iterationStatement : WHILE '(' expression ')' statement",
	"iterationStatement : DO statement WHILE '(' expression ')' ';'",
	"iterationStatement : FOR '(' initForStatement optExpression ';' optExpression ')' statement",
	"optExpression : /* empty */",
	"optExpression : expression",
	"initForStatement : expressionStatement",
	"initForStatement : declarationStatement",
	"jumpStatement : BREAK ';'",
	"jumpStatement : CONTINUE ';'",
	"jumpStatement : RETURN expression ';'",
	"jumpStatement : RETURN ';'",
	"declarationStatement : declaration",
};
#endif /* YYDEBUG */
/*
 * Copyright (c) 1993 by Sun Microsystems, Inc.
 */

#pragma ident	"@(#)yaccpar	6.12	93/06/07 SMI"

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#define YYNEW(type)	malloc(sizeof(type) * yynewmax)
#define YYCOPY(to, from, type) \
	(type *) memcpy(to, (char *) from, yynewmax * sizeof(type))
#define YYENLARGE( from, type) \
	(type *) realloc((char *) from, yynewmax * sizeof(type))
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-10000000)

/*
** global variables used by the parser
*/
YYSTYPE *yypv;			/* top of value stack */
int *yyps;			/* top of state stack */

int yystate;			/* current state */
int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */
int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */



#ifdef YYNMBCHARS
#define YYLEX()		yycvtok(yylex())
/*
** yycvtok - return a token if i is a wchar_t value that exceeds 255.
**	If i<255, i itself is the token.  If i>255 but the neither 
**	of the 30th or 31st bit is on, i is already a token.
*/
#if defined(__STDC__) || defined(__cplusplus)
int yycvtok(int i)
#else
int yycvtok(i) int i;
#endif
{
	int first = 0;
	int last = YYNMBCHARS - 1;
	int mid;
	wchar_t j;

	if(i&0x60000000){/*Must convert to a token. */
		if( yymbchars[last].character < i ){
			return i;/*Giving up*/
		}
		while ((last>=first)&&(first>=0)) {/*Binary search loop*/
			mid = (first+last)/2;
			j = yymbchars[mid].character;
			if( j==i ){/*Found*/ 
				return yymbchars[mid].tvalue;
			}else if( j<i ){
				first = mid + 1;
			}else{
				last = mid -1;
			}
		}
		/*No entry in the table.*/
		return i;/* Giving up.*/
	}else{/* i is already a token. */
		return i;
	}
}
#else/*!YYNMBCHARS*/
#define YYLEX()		yylex()
#endif/*!YYNMBCHARS*/

/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
#if defined(__STDC__) || defined(__cplusplus)
int yyparse(void)
#else
int yyparse()
#endif
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */

#if defined(__cplusplus) || defined(lint)
/*
	hacks to please C++ and lint - goto's inside switch should never be
	executed; yypvt is set to 0 to avoid "used before set" warning.
*/
	static int __yaccpar_lint_hack__ = 0;
	switch (__yaccpar_lint_hack__)
	{
		case 1: goto yyerrlab;
		case 2: goto yynewstate;
	}
	yypvt = 0;
#endif

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

#if YYMAXDEPTH <= 0
	if (yymaxdepth <= 0)
	{
		if ((yymaxdepth = YYEXPAND(0)) <= 0)
		{
			yyerror("yacc initialization error");
			YYABORT;
		}
	}
#endif

	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */
	goto yystack;	/* moved from 6 lines above to here to please C++ */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int yyps_index = (yy_ps - yys);
			int yypv_index = (yy_pv - yyv);
			int yypvt_index = (yypvt - yyv);
			int yynewmax;
#ifdef YYEXPAND
			yynewmax = YYEXPAND(yymaxdepth);
#else
			yynewmax = 2 * yymaxdepth;	/* double table size */
			if (yymaxdepth == YYMAXDEPTH)	/* first time growth */
			{
				char *newyys = (char *)YYNEW(int);
				char *newyyv = (char *)YYNEW(YYSTYPE);
				if (newyys != 0 && newyyv != 0)
				{
					yys = YYCOPY(newyys, yys, int);
					yyv = YYCOPY(newyyv, yyv, YYSTYPE);
				}
				else
					yynewmax = 0;	/* failed */
			}
			else				/* not first time */
			{
				yys = YYENLARGE(yys, int);
				yyv = YYENLARGE(yyv, YYSTYPE);
				if (yys == 0 || yyv == 0)
					yynewmax = 0;	/* failed */
			}
#endif
			if (yynewmax <= yymaxdepth)	/* tables not expanded */
			{
				yyerror( "yacc stack overflow" );
				YYABORT;
			}
			yymaxdepth = yynewmax;

			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			printf( "Received token " );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				printf( "Received token " );
				if ( yychar == 0 )
					printf( "end-of-file\n" );
				else if ( yychar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
			skip_init:
				yynerrs++;
				/* FALLTHRU */
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					printf( "Error recovery discards " );
					if ( yychar == 0 )
						printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 1:
# line 250 "aslcyacc.y"
{ 
						  compiler.parser.setLexState(0);        
						  compiler.parser.incNumOfSchemas();
						  flagAssign = 2;
						} break;
case 2:
# line 257 "aslcyacc.y"
{ compiler.parser.insertSchema(yypvt[-0].name,TRUE); } break;
case 3:
# line 258 "aslcyacc.y"
{ compiler.parser.setLexState(0);flagAssign = 2; } break;
case 4:
# line 262 "aslcyacc.y"
{ compiler.parser.setLexState(0);flagAssign = 2; } break;
case 5:
# line 266 "aslcyacc.y"
{
						  compiler.parser.setLexState(0);
						  compiler.parser.incNumOfSchemas();
						  flagAssign = 2;
						} break;
case 6:
# line 274 "aslcyacc.y"
{ compiler.parser.insertSchema(yypvt[-0].name,TRUE); } break;
case 7:
# line 275 "aslcyacc.y"
{ compiler.parser.setLexState(0);flagAssign = 2; } break;
case 8:
# line 280 "aslcyacc.y"
{ compiler.parser.setLexState(0);flagAssign = 2; } break;
case 10:
# line 287 "aslcyacc.y"
{
						  compiler.parser.makeConstructorDecl(compiler.parser.getActualSchema());
					  	  compiler.parser.makeDestructorDecl(compiler.parser.getActualSchema());
					  	  strcpy(myAssign,"");
						} break;
case 11:
# line 294 "aslcyacc.y"
{
						  compiler.parser.makeConstructor(compiler.parser.getActualSchema());
					  	  compiler.parser.makeDestructor(compiler.parser.getActualSchema());
						} break;
case 12:
# line 301 "aslcyacc.y"
{
						  flagSchema=TRUE;
						  compiler.parser.insertSchema(yypvt[-0].name,FALSE); 
						  compiler.parser.setActualSchema(yypvt[-0].name);
						} break;
case 13:
# line 306 "aslcyacc.y"
{ flagSchema=FALSE;} break;
case 14:
# line 307 "aslcyacc.y"
{ flagSchema=FALSE;} break;
case 15:
# line 310 "aslcyacc.y"
{
						  flagSchema=TRUE;
						  AslSchemaSymbol *res;
						  res = compiler.parser.searchSchema(yypvt[-0].name);
						  if (!res->isPrototype())
							{
							  sprintf(compiler.buf,"Schema [%s] already defined", yypvt[-0].name);
							  compiler.semanticError(compiler.buf);
							}
						  else
							{
							  res->setPrototype(FALSE);
							} 
						} break;
case 16:
# line 325 "aslcyacc.y"
{ flagSchema=FALSE;} break;
case 17:
# line 326 "aslcyacc.y"
{ flagSchema=FALSE;} break;
case 18:
# line 328 "aslcyacc.y"
{ compiler.sintaxError("Schema Header sintax error"); } break;
case 19:
# line 332 "aslcyacc.y"
{ flagSchema=FALSE; } break;
case 20:
# line 335 "aslcyacc.y"
{ flagSchema=FALSE; } break;
case 21:
# line 339 "aslcyacc.y"
{ compiler.parser.setActualExtends(""); flagSchema=FALSE;} break;
case 22:
# line 340 "aslcyacc.y"
{ flagSchema=FALSE; flagObject=FALSE;} break;
case 23:
# line 342 "aslcyacc.y"
{ flagSchema=FALSE;} break;
case 24:
# line 345 "aslcyacc.y"
{ compiler.parser.setActualExtends(yypvt[-0].name);
							  flagSchema=TRUE;
							} break;
case 25:
# line 349 "aslcyacc.y"
{ 
						  	  sprintf(compiler.buf,"Identifier [%s] is not a schema", yypvt[-0].name);
					   	  	  compiler.semanticError(compiler.buf);
							} break;
case 26:
# line 354 "aslcyacc.y"
{ 
							  sprintf(compiler.buf,"Identifier [%s] is not a schema", yypvt[-0].name);
							  compiler.semanticError(compiler.buf);
				     			} break;
case 28:
# line 362 "aslcyacc.y"
{flagExtends = TRUE;} break;
case 29:
# line 364 "aslcyacc.y"
{flagExtends = FALSE;} break;
case 33:
# line 370 "aslcyacc.y"
{ compiler.sintaxError("MyBad schema member sintax"); } break;
case 34:
# line 373 "aslcyacc.y"
{ compiler.parser.setAccess(EXT); } break;
case 35:
# line 374 "aslcyacc.y"
{ compiler.parser.setAccess(INT); } break;
case 36:
# line 383 "aslcyacc.y"
{ if (flagObject) flagObject = FALSE; 
			  			  if (flagAssign) flagAssign = FALSE; 
			  			} break;
case 37:
# line 389 "aslcyacc.y"
{ compiler.parser.insertFunction(compiler.parser.getActualIdentifier()); } break;
case 39:
# line 394 "aslcyacc.y"
{ strcpy(yyval.name, yypvt[-0].name); compiler.parser.setActualType(yyval.name); } break;
case 40:
# line 395 "aslcyacc.y"
{ strcat(yyval.name, yypvt[-0].name); compiler.parser.setActualType(yyval.name); } break;
case 41:
# line 398 "aslcyacc.y"
{ strcpy(yyval.name, ""); } break;
case 42:
# line 399 "aslcyacc.y"
{ strcpy(yyval.name, yypvt[-0].name); } break;
case 43:
# line 402 "aslcyacc.y"
{ strcpy(yyval.name, ""); } break;
case 44:
# line 403 "aslcyacc.y"
{ strcpy(yyval.name, ""); } break;
case 45:
# line 404 "aslcyacc.y"
{ strcpy(yyval.name, ""); } break;
case 46:
# line 405 "aslcyacc.y"
{ strcpy(yyval.name, ""); } break;
case 47:
# line 408 "aslcyacc.y"
{ strcpy(yyval.name, ""); compiler.parser.setActualAccessOption(yyval.name); } break;
case 48:
# line 409 "aslcyacc.y"
{ compiler.parser.setActualAccessOption(yyval.name);} break;
case 49:
# line 412 "aslcyacc.y"
{ strcpy(yyval.name, yypvt[-1].name); } break;
case 50:
# line 413 "aslcyacc.y"
{ strcpy(yyval.name, yypvt[-1].name);flagObject= TRUE;} break;
case 51:
# line 414 "aslcyacc.y"
{ strcpy(yyval.name, ""); } break;
case 52:
# line 417 "aslcyacc.y"
{ strcpy(yyval.name, "char"); 	  } break;
case 53:
# line 418 "aslcyacc.y"
{ strcpy(yyval.name, "double");   } break;
case 54:
# line 419 "aslcyacc.y"
{ strcpy(yyval.name, "float"); 	  } break;
case 55:
# line 420 "aslcyacc.y"
{ strcpy(yyval.name, "input"); 	  } break;
case 56:
# line 421 "aslcyacc.y"
{ strcpy(yyval.name, "int"); 	  } break;
case 57:
# line 422 "aslcyacc.y"
{ strcpy(yyval.name, "long"); 	  } break;
case 58:
# line 423 "aslcyacc.y"
{ strcpy(yyval.name, "NslString");} break;
case 59:
# line 424 "aslcyacc.y"
{ strcpy(yyval.name, "output");   } break;
case 60:
# line 425 "aslcyacc.y"
{ strcpy(yyval.name, "signed");   } break;
case 61:
# line 426 "aslcyacc.y"
{ strcpy(yyval.name, "short"); 	  } break;
case 62:
# line 427 "aslcyacc.y"
{ strcpy(yyval.name, "unsigned"); } break;
case 63:
# line 428 "aslcyacc.y"
{ strcpy(yyval.name, "void");     } break;
case 64:
# line 431 "aslcyacc.y"
{ strcpy(yyval.name, "NslDinDouble"); 	} break;
case 65:
# line 432 "aslcyacc.y"
{ strcpy(yyval.name, "NslDinDouble1"); 	} break;
case 66:
# line 433 "aslcyacc.y"
{ strcpy(yyval.name, "NslDinDouble2"); 	} break;
case 67:
# line 434 "aslcyacc.y"
{ strcpy(yyval.name, "NslDinDouble3"); 	} break;
case 68:
# line 435 "aslcyacc.y"
{ strcpy(yyval.name, "NslDinDouble4"); 	} break;
case 69:
# line 436 "aslcyacc.y"
{ strcpy(yyval.name, "NslDinFloat"); 	} break;
case 70:
# line 437 "aslcyacc.y"
{ strcpy(yyval.name, "NslDinFloat1");	} break;
case 71:
# line 438 "aslcyacc.y"
{ strcpy(yyval.name, "NslDinFloat2"); 	} break;
case 72:
# line 439 "aslcyacc.y"
{ strcpy(yyval.name, "NslDinFloat3"); 	} break;
case 73:
# line 440 "aslcyacc.y"
{ strcpy(yyval.name, "NslDinFloat4"); 	} break;
case 74:
# line 441 "aslcyacc.y"
{ strcpy(yyval.name, "NslDinInt"); 	} break;
case 75:
# line 442 "aslcyacc.y"
{ strcpy(yyval.name, "NslDinInt1"); 	} break;
case 76:
# line 443 "aslcyacc.y"
{ strcpy(yyval.name, "NslDinInt2"); 	} break;
case 77:
# line 444 "aslcyacc.y"
{ strcpy(yyval.name, "NslDinInt3"); 	} break;
case 78:
# line 445 "aslcyacc.y"
{ strcpy(yyval.name, "NslDinInt4"); 	} break;
case 79:
# line 446 "aslcyacc.y"
{ strcpy(yyval.name, "NslDoutDouble"); 	} break;
case 80:
# line 447 "aslcyacc.y"
{ strcpy(yyval.name, "NslDoutDouble1"); } break;
case 81:
# line 448 "aslcyacc.y"
{ strcpy(yyval.name, "NslDoutDouble2"); } break;
case 82:
# line 449 "aslcyacc.y"
{ strcpy(yyval.name, "NslDoutDouble3"); } break;
case 83:
# line 450 "aslcyacc.y"
{ strcpy(yyval.name, "NslDoutDouble4"); } break;
case 84:
# line 451 "aslcyacc.y"
{ strcpy(yyval.name, "NslDoutFloat"); 	} break;
case 85:
# line 452 "aslcyacc.y"
{ strcpy(yyval.name, "NslDoutFloat1"); 	} break;
case 86:
# line 453 "aslcyacc.y"
{ strcpy(yyval.name, "NslDoutFloat2"); 	} break;
case 87:
# line 454 "aslcyacc.y"
{ strcpy(yyval.name, "NslDoutFloat3"); 	} break;
case 88:
# line 455 "aslcyacc.y"
{ strcpy(yyval.name, "NslDoutFloat4"); 	} break;
case 89:
# line 456 "aslcyacc.y"
{ strcpy(yyval.name, "NslDoutInt"); 	} break;
case 90:
# line 457 "aslcyacc.y"
{ strcpy(yyval.name, "NslDoutInt1"); 	} break;
case 91:
# line 458 "aslcyacc.y"
{ strcpy(yyval.name, "NslDoutInt2"); 	} break;
case 92:
# line 459 "aslcyacc.y"
{ strcpy(yyval.name, "NslDoutInt3"); 	} break;
case 93:
# line 460 "aslcyacc.y"
{ strcpy(yyval.name, "NslDoutInt4"); 	} break;
case 94:
# line 461 "aslcyacc.y"
{ strcpy(yyval.name, "NslDouble"); 	} break;
case 95:
# line 462 "aslcyacc.y"
{ strcpy(yyval.name, "NslDouble0"); 	} break;
case 96:
# line 463 "aslcyacc.y"
{ strcpy(yyval.name, "NslDouble1"); 	} break;
case 97:
# line 464 "aslcyacc.y"
{ strcpy(yyval.name, "NslDouble2"); 	} break;
case 98:
# line 465 "aslcyacc.y"
{ strcpy(yyval.name, "NslDouble3"); 	} break;
case 99:
# line 466 "aslcyacc.y"
{ strcpy(yyval.name, "NslDouble4"); 	} break;
case 100:
# line 467 "aslcyacc.y"
{ strcpy(yyval.name, "NslFloat"); 	} break;
case 101:
# line 468 "aslcyacc.y"
{ strcpy(yyval.name, "NslFloat0"); 	} break;
case 102:
# line 469 "aslcyacc.y"
{ strcpy(yyval.name, "NslFloat1"); 	} break;
case 103:
# line 470 "aslcyacc.y"
{ strcpy(yyval.name, "NslFloat2"); 	} break;
case 104:
# line 471 "aslcyacc.y"
{ strcpy(yyval.name, "NslFloat3"); 	} break;
case 105:
# line 472 "aslcyacc.y"
{ strcpy(yyval.name, "NslFloat4"); 	} break;
case 106:
# line 473 "aslcyacc.y"
{ strcpy(yyval.name, "NslInt"); 	} break;
case 107:
# line 474 "aslcyacc.y"
{ strcpy(yyval.name, "NslInt0"); 	} break;
case 108:
# line 475 "aslcyacc.y"
{ strcpy(yyval.name, "NslInt1"); 	} break;
case 109:
# line 476 "aslcyacc.y"
{ strcpy(yyval.name, "NslInt2"); 	} break;
case 110:
# line 477 "aslcyacc.y"
{ strcpy(yyval.name, "NslInt3"); 	} break;
case 111:
# line 478 "aslcyacc.y"
{ strcpy(yyval.name, "NslInt4"); 	} break;
case 112:
# line 479 "aslcyacc.y"
{ strcpy(yyval.name, yypvt[-0].name);} break;
case 115:
# line 486 "aslcyacc.y"
{ if (flagObject) compiler.putInOutFile(","); 
						  flagAssign=TRUE;
						  flagSchema=TRUE;
						} break;
case 117:
# line 494 "aslcyacc.y"
{ if (flagObject) compiler.parser.insertObject(compiler.parser.getActualType(), compiler.parser.getActualAccessOption(), compiler.parser.getActualIdentifier());
					} break;
case 118:
# line 497 "aslcyacc.y"
{ if (flagObject) strcpy(myArgument,"");} break;
case 119:
# line 498 "aslcyacc.y"
{ if (flagObject) compiler.parser.insertObjectArguments(myArgument);} break;
case 124:
# line 508 "aslcyacc.y"
{ 
				  	  	  if (flagAssign)
						    {
							strcat(myAssign,compiler.parser.getActualIdentifier());
							strcat(myAssign," = ");
						    }
						} break;
case 127:
# line 519 "aslcyacc.y"
{ if (!strcmp(yypvt[-0].name, "0")) compiler.sintaxError("Pure specifier need to be '= 0'"); } break;
case 129:
# line 523 "aslcyacc.y"
{ 
				  	  	  	  if (flagAssign) 
				  	  	  	    {
				  	  	  	    	strcat(myAssign,compiler.parser.getActualIdentifier());
				  	  	  	    	strcat(myAssign," = ");
				  	  	  	    }
							} break;
case 131:
# line 533 "aslcyacc.y"
{  	
								compiler.parser.insertIdentifier(yypvt[-0].name);
							} break;
case 132:
# line 537 "aslcyacc.y"
{ 
							  if (!flagExtends)
							    {		
								sprintf(compiler.buf,"MyIdentifier [%s] already defined", yypvt[-0].name);
								compiler.semanticError(compiler.buf);
							    }
							} break;
case 137:
# line 554 "aslcyacc.y"
{strcpy(yyval.name,"*");} break;
case 138:
# line 555 "aslcyacc.y"
{strcpy(yyval.name,"&");} break;
case 144:
# line 567 "aslcyacc.y"
{
						  compiler.parser.insertArg(compiler.parser.getActualType(), compiler.parser.getActualAccessOption(), compiler.parser.getActualIdentifier(), flagExtends);
						} break;
case 157:
# line 592 "aslcyacc.y"
{ if (flagAssign) strcat(myAssign,"-"); } break;
case 175:
# line 634 "aslcyacc.y"
{if (flagObject) strcat(myArgument,",");} break;
case 235:
# line 735 "aslcyacc.y"
{ if (flagObject) { strcat(myArgument,"+");	}
			  			  if (flagAssign) { strcat(myAssign,"+");	}
			  			} break;
case 237:
# line 740 "aslcyacc.y"
{ if (flagObject) { strcat(myArgument,"-");	}
			  			  if (flagAssign) { strcat(myAssign,"-");	}
			  			} break;
case 240:
# line 748 "aslcyacc.y"
{ if (flagObject) { strcat(myArgument,"*");	}
			  			  if (flagAssign) { strcat(myAssign,"*");	}
			  			} break;
case 242:
# line 753 "aslcyacc.y"
{ if (flagObject) { strcat(myArgument,"/");	}
			  			  if (flagAssign) { strcat(myAssign,"/");	}
			  			} break;
case 244:
# line 758 "aslcyacc.y"
{ if (flagObject) { strcat(myArgument,"%");	}
			  			  if (flagAssign) { strcat(myAssign,"%");	}
			  			} break;
case 259:
# line 784 "aslcyacc.y"
{ if (flagObject) { strcat(myArgument,"*");	}
						  if (flagAssign) { strcat(myAssign,"*");	}
						} break;
case 260:
# line 787 "aslcyacc.y"
{ if (flagObject) { strcat(myArgument,"&");	}
						  if (flagAssign) { strcat(myAssign,"&");	}
						} break;
case 261:
# line 790 "aslcyacc.y"
{ if (flagObject) { strcat(myArgument,"+");	}
						  if (flagAssign) { strcat(myAssign,"+");	}
						} break;
case 262:
# line 793 "aslcyacc.y"
{ if (flagObject) { strcat(myArgument,"-");	}
						  if (flagAssign) { strcat(myAssign,"-");	}
						} break;
case 263:
# line 796 "aslcyacc.y"
{ if (flagObject) { strcat(myArgument,"!");	}
						  if (flagAssign) { strcat(myAssign,"!");	}
						} break;
case 264:
# line 799 "aslcyacc.y"
{ if (flagObject) { strcat(myArgument,"~");	}
						  if (flagAssign) { strcat(myAssign,"~");	}
						} break;
case 281:
# line 829 "aslcyacc.y"
{ 
						  if (flagObject) 
						    {
							strcat(myArgument,"\"");
							strcat(myArgument,compiler.parser.getActualIdentifier());
							strcat(myArgument,"\"");
						    }
						  else
						    {
							compiler.putInOutFile("\"");
							compiler.putInOutFile(compiler.parser.getActualIdentifier());
							compiler.putInOutFile("\"");
						    }
						} break;
case 282:
# line 844 "aslcyacc.y"
{ if (flagObject) strcat(myArgument,myStack);} break;
case 283:
# line 846 "aslcyacc.y"
{ if (flagObject) strcat(myArgument,"(");
						  if (flagAssign) strcat(myAssign,"(");
						} break;
case 284:
# line 850 "aslcyacc.y"
{ if (flagObject) strcat(myArgument,")");
			  			  if (flagAssign) strcat(myAssign,")");
			  			} break;
case 285:
# line 854 "aslcyacc.y"
{ if (flagObject) strcat(myArgument,yypvt[-0].name);
						  if (flagAssign) strcat(myAssign,yypvt[-0].name);
						} break;
case 286:
# line 858 "aslcyacc.y"
{ if (flagObject) strcat(myArgument,yypvt[-0].name);
						  if (flagAssign) strcat(myAssign,yypvt[-0].name);
						} break;
case 287:
# line 863 "aslcyacc.y"
{ if (flagObject) strcat(myArgument,myStack);} break;
case 288:
# line 864 "aslcyacc.y"
{ if (flagObject) strcat(myArgument,myStack);} break;
case 289:
# line 865 "aslcyacc.y"
{ if (flagObject) strcat(myArgument,myStack);} break;
case 290:
# line 866 "aslcyacc.y"
{ if (flagObject) strcat(myArgument,myStack);} break;
case 302:
# line 892 "aslcyacc.y"
{ compiler.parser.incScope(); } break;
case 303:
# line 894 "aslcyacc.y"
{ compiler.parser.decScope(); } break;
	}
	goto yystack;		/* reset registers in driver code */
}

