/**************************************************************/
/*                                                            */
/*                   nsl_cmd_stim_3d.C             			  */
/*                                                            */
/**************************************************************/

# include "nsl_all_kernel_include.h"
# include "nsl_all_input_include.h"

nsl_cmd_stim_3d::nsl_cmd_stim_3d()
{
	set_type("stim_3d");
}

nsl_cmd_stim_3d::~nsl_cmd_stim_3d()
{
}
int nsl_cmd_stim_3d::cmd_clear(nsl_interpreter&)
{
 	return 1;
}
int nsl_cmd_stim_3d::cmd_create(nsl_interpreter&)
{
	return 1;
}
int nsl_cmd_stim_3d::cmd_reset(nsl_interpreter&)
{
	return 1;
}
int nsl_cmd_stim_3d::cmd_update(nsl_interpreter&)
{
 	return 1;
}
int nsl_cmd_stim_3d::init_data(nsl_base* stim)
{
	num_type fval = 0;
 	nsl_cmd_type* data;
 	nsl_base* pbase;
	nsl_list* list = 0;
	spec_type_enum spec_type = NSL_CORNER;
	stim_type_enum stim_type = NSL_BLOCK;

	nsl_cmd_stim_matrix::init_data(stim);

	pbase = SYSTEM->get_cmd_system()->
	     get_m_children_list()->get_mi_by_type(get_base_type());
	if (pbase != NULL)
		list = ((nsl_cmd_type*) pbase)->get_data_list();
	else
		cmd_error("cmd: NULL parent type");

	if (list != NULL)
	{
	  if ((data = (nsl_cmd_type*) list->get_by_name("spec_type")) != NULL)
	  {
		spec_type = ((nsl_stim_matrix*) stim)->get_spec_type();
		((nsl_spec_type_data*) data)->set_value(spec_type);
 	  }
	  else
		cmd_error("nsl_cmd_stim_matrix: NULL 'stim_type' obj");

	  if (spec_type == NSL_CORNER)
	  {
	    if ((data = (nsl_cmd_type*) list->get_by_name("z0")) != NULL)
	    {
			fval = ((nsl_stim_3d*) stim)->get_z0();
			((nsl_num_data*) data)->set_value(fval);
	    }
	    else
			cmd_error("nsl_cmd_stim_3d: NULL 'z0' obj");
	  }
	  else
	  {
	    if ((data = (nsl_cmd_type*) list->get_by_name("zc")) != NULL)
	    {
			fval = ((nsl_stim_3d*) stim)->get_zc();
			((nsl_num_data*) data)->set_value(fval);
	    }
	    else
			cmd_error("nsl_cmd_stim_3d: NULL 'zc' obj");
	  }

	  if ((data = (nsl_cmd_type*) list->get_by_name("dz")) != NULL)
	  {
		fval = ((nsl_stim_3d*) stim)->get_dz();
		((nsl_num_data*) data)->set_value(fval);
	  }
	  else
		cmd_error("nsl_cmd_stim_3d: NULL 'dz' obj");

	  if ((data = (nsl_cmd_type*) list->get_by_name("vz")) != NULL)
	  {
		fval = ((nsl_stim_3d*) stim)->get_vz();
		((nsl_num_data*) data)->set_value(fval);
	  }
	  else
		cmd_error("nsl_cmd_stim_3d: NULL 'vz' obj");

	}

	return 1;
}

int nsl_cmd_stim_3d::update_data(nsl_base* stim,
	int,int,int,int,int,int,int,int,int,int)
{
	num_type fval = 0;
 	nsl_cmd_type* data;
	nsl_base* pbase;
	nsl_list* list = 0;
	spec_type_enum spec_type = NSL_CORNER;
	stim_type_enum stim_type = NSL_BLOCK;

 	nsl_cmd_stim_matrix::update_data(stim);

	pbase = SYSTEM->get_cmd_system()->
	     get_m_children_list()->get_mi_by_type(get_base_type());
	if (pbase != NULL)
		list = ((nsl_cmd_type*) pbase)->get_data_list();
	else
		cmd_error("cmd: NULL parent type");
	if (list != NULL)
	{
	  if ((data = (nsl_cmd_type*) list->get_by_name("spec_type")) != NULL)
	  {
		spec_type = ((nsl_spec_type_data*) data)->get_value();
		((nsl_stim_matrix*) stim)->set_spec_type(spec_type);
	  }
	  else
		cmd_error("nsl_cmd_stim_matrix: NULL 'stim_type' obj");

	  if (spec_type == NSL_CORNER)
	  {
	    if ((data = (nsl_cmd_type*) list->get_by_name("z0")) != NULL)
	    {
			fval = ((nsl_num_data*) data)->get_value();
			((nsl_stim_3d*) stim)->set_z0(fval);
	    }
	    else
			cmd_error("nsl_cmd_stim_3d: NULL 'z0' obj");
	  }
	  else
	  {
	    if ((data = (nsl_cmd_type*) list->get_by_name("zc")) != NULL)
	    {
			fval = ((nsl_num_data*) data)->get_value();
			((nsl_stim_3d*) stim)->set_zc(fval);
	    }
	    else
			cmd_error("nsl_cmd_stim_3d: NULL 'zc' obj");
	  }

	  if ((data = (nsl_cmd_type*) list->get_by_name("dz")) != NULL)
	  {
		fval = ((nsl_num_data*) data)->get_value();
	   	((nsl_stim_3d*) stim)->set_dz(fval);
	  }
	  else
		cmd_error("nsl_cmd_stim_3d: NULL 'dz' obj");

	  if ((data = (nsl_cmd_type*) list->get_by_name("vz")) != NULL)
	  {
		fval = ((nsl_num_data*) data)->get_value();
	   	((nsl_stim_3d*) stim)->set_vz(fval);
	  }
	  else
		cmd_error("nsl_cmd_stim_3d: NULL 'vz' obj");
	}

	return 1;
}
