/* SCCS  @(#)nsl_vec_to_mat_library.h	1.2---95/08/14--16:08:57 */
/****************************************************************/
/*                                                           	*/
/*                  nsl_vec_to_mat_library.h                    */
/*                                                            	*/
/****************************************************************/
/*
extern nsl_num_2<NslNumType,NslTypeId> nslExpand(const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern nsl_num_2<NslNumType,NslTypeId> nslExpandCols(const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern nsl_num_2<NslNumType,NslTypeId> nslExpandRows(const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern nsl_num_2<NslNumType,NslTypeId> nslExpandCols(const nsl_num_1<NslNumType,NslTypeId>&,const int);
extern nsl_num_2<NslNumType,NslTypeId> nslExpandRows(const nsl_num_1<NslNumType,NslTypeId>&,const int);

extern nsl_num_2<NslNumType,NslTypeId> NSLvec_to_mat(const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern nsl_num_2<NslNumType,NslTypeId> NSLcol_vec_to_mat(const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern nsl_num_2<NslNumType,NslTypeId> NSLrow_vec_to_mat(const nsl_num_2<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern nsl_num_2<NslNumType,NslTypeId> NSLcol_vec_to_mat(const nsl_num_1<NslNumType,NslTypeId>&,const int);
extern nsl_num_2<NslNumType,NslTypeId> NSLrow_vec_to_mat(const nsl_num_1<NslNumType,NslTypeId>&,const int);
*/

template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> nslExpand(const nsl_num_2<NslNumType,NslTypeId>& ref,const nsl_num_1<NslNumType,NslTypeId>& a) // NSLvec_to_mat
{
	int vec_type = a.get_vec_type();

	int simax = ref.get_imax();
	int sjmax = ref.get_jmax();

	int s = a.get_imax();

	nsl_num_2<NslNumType,NslTypeId> c(simax,sjmax);
	
	if (vec_type == 0) // row vector
	{
	    if (s != sjmax)
	    {
		cmd_error("*** nslExpand ***");
		cmd_error("vector jmax: ",s);
		cmd_error("matrix jmax: ",sjmax);
		cmd_error("Bad vector size");
		return c;
	    }

	    for (int i = 0; i < simax; i++)
	    	for (int j = 0; j < sjmax; j++)
		    c[i][j] = a[j];
	}
	if (vec_type == 1) // col vector
	{
	    if (s != simax)
	    {
		cmd_error("*** NSLvec_to_mat ***");
		cmd_error("vector imax: ",s);
		cmd_error("matrix imax: ",simax);
		cmd_error("Bad vector size");
		return c;
	    }

	    for (int i = 0; i < simax; i++)
	    	for (int j = 0; j < sjmax; j++)
		    c[i][j] = a[i];
	}

	return c;
}

template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> nslExpandRows(const nsl_num_2<NslNumType,NslTypeId>& ref,const nsl_num_1<NslNumType,NslTypeId>& a) // NSLrow_vec_to_mat
{
	int simax = ref.get_imax();
	int sjmax = ref.get_jmax();

	int s = a.get_imax();

	nsl_num_2<NslNumType,NslTypeId> c(simax,sjmax);

	if (s != sjmax)
	{
		cmd_error("*** nslExpandRows ***");
		cmd_error("vector jmax: ",s);
		cmd_error("matrix jmax: ",sjmax);
		cmd_error("Bad vector size");
		return c;
	}

	for (int i = 0; i < simax; i++)
	    for (int j = 0; j < sjmax; j++)
		c[i][j] = a[j];

	return c;
}

template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> nslExpandCols(const nsl_num_2<NslNumType,NslTypeId>& ref,const nsl_num_1<NslNumType,NslTypeId>& a) // NSLcol_vec_to_mat
{ 
	int simax = ref.get_imax();
	int sjmax = ref.get_jmax();

	int s = a.get_imax();

	nsl_num_2<NslNumType,NslTypeId> c(simax,sjmax);

	if (s != simax)
	{
		cmd_error("*** nslExpandCols ***");
		cmd_error("vector imax: ",s);
		cmd_error("matrix imax: ",simax);
		cmd_error("Bad vector size");
		return c;
	}

	for (int i = 0; i < simax; i++)
	    for (int j = 0; j < sjmax; j++)
		c[i][j] = a[i];

	return c; 
}

template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> nslExpandRows(const nsl_num_1<NslNumType,NslTypeId>& a,const int simax) // NSLrow_vec_to_mat
{
	int sjmax = a.get_imax();

	nsl_num_2<NslNumType,NslTypeId> c(simax,sjmax);

	for (int i = 0; i < simax; i++)
	    for (int j = 0; j < sjmax; j++)
		c[i][j] = a[j];

	return c;
}

template<class NslNumType, int NslTypeId>
nsl_num_2<NslNumType,NslTypeId> nslExpandCols(const nsl_num_1<NslNumType,NslTypeId>& a,const int sjmax) // NSLcol_vec_to_mat
{
	int simax = a.get_imax();

	nsl_num_2<NslNumType,NslTypeId> c(simax,sjmax);
	
	for (int i = 0; i < simax; i++)
	    for (int j = 0; j < sjmax; j++)
		c[i][j] = a[i];

	return c;
}
