/* SCCS  @(#)nsl_num_1<NslNumType,NslTypeId>_add_library.h	1.1---95/08/13--23:38:58 */
//
// nsl_num_1<NslNumType,NslTypeId>_add_library.h
//
/*
extern 	nsl_num_1<NslNumType,NslTypeId> 	operator+(const nsl_num_1<NslNumType,NslTypeId>&);
extern	nsl_num_1<NslNumType,NslTypeId> 	operator+(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern 	nsl_num_1<NslNumType,NslTypeId> 	operator+(const nsl_num_1<NslNumType,NslTypeId>&,const NslNumType);
extern 	nsl_num_1<NslNumType,NslTypeId> 	operator+(const NslNumType,const nsl_num_1<NslNumType,NslTypeId>&);
extern	nsl_num_1<NslNumType,NslTypeId> 	operator+(const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern	nsl_num_1<NslNumType,NslTypeId> 	operator+(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);

extern void NSLadd_equal(nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_2<NslNumType,NslTypeId>&);
extern void NSLadd_equal(nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern void NSLadd_equal(nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);

extern void NSLadd_plus(nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern void NSLadd_plus(nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);

extern void NSLadd_minus(nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern void NSLadd_minus(nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
*/

template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator+(const nsl_num_1<NslNumType,NslTypeId>& a)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator+\n";
	cout << "// (vector) " << " = (vector) ";
	cout << a.get_name() << ";\n";
	cout.flush();
#endif

	int aimax = a.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(aimax);

	for (int i = 0; i < aimax; i++)
		c[i] = a[i];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator+(const nsl_num_1<NslNumType,NslTypeId>& a,const nsl_num_1<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator+\n";
	cout << "// (vector) " << a.get_name() << " + (vector) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	int aimax = a.get_imax();
	int bimax = b.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(aimax);

	if (aimax != bimax)
	{
		cmd_error("*** nsl_num_1<NslNumType,NslTypeId>::operator+ ***");
		cmd_error("Exit with status:");
		a.print_status(cerr);
		b.print_status(cerr);
		cmd_error("Inconsistent vector sizes");
		return c;
	}

	for (int i = 0; i < aimax; i++)
		c[i] = a[i] + b[i];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator+(const nsl_num_1<NslNumType,NslTypeId>& a,const float b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator+\n";
	cout << "// (vector) " << a.get_name() << " + (NslNumType) ";
	cout << b << ";\n";
	cout.flush();
#endif

	int aimax = a.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(aimax);

	for (int i = 0; i < aimax; i++)
		c[i] = a[i] + b;

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator+(const nsl_num_1<NslNumType,NslTypeId>& a,const double b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator+\n";
	cout << "// (vector) " << a.get_name() << " + (NslNumType) ";
	cout << b << ";\n";
	cout.flush();
#endif

	int aimax = a.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(aimax);

	for (int i = 0; i < aimax; i++)
		c[i] = a[i] + b;

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator+(const nsl_num_1<NslNumType,NslTypeId>& a,const int b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator+\n";
	cout << "// (vector) " << a.get_name() << " + (NslNumType) ";
	cout << b << ";\n";
	cout.flush();
#endif

	int aimax = a.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(aimax);

	for (int i = 0; i < aimax; i++)
		c[i] = a[i] + b;

	return c;
}

template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator+(const float a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator+\n";
	cout << "// (NslNumType) " << a << " + (vector) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	int bimax = b.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(bimax);

	for (int i = 0; i < bimax; i++)
		c[i] = a + b[i];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator+(const double a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator+\n";
	cout << "// (NslNumType) " << a << " + (vector) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	int bimax = b.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(bimax);

	for (int i = 0; i < bimax; i++)
		c[i] = a + b[i];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator+(const int a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator+\n";
	cout << "// (NslNumType) " << a << " + (vector) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	int bimax = b.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(bimax);

	for (int i = 0; i < bimax; i++)
		c[i] = a + b[i];

	return c;
}

template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator+(const nsl_num_1<NslNumType,NslTypeId>& a,const nsl_num_0<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator+\n";
	cout << "// (vector) " << a.get_name() << " + (data) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	int aimax = a.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(aimax);

	for (int i = 0; i < aimax; i++)
		c[i] = a[i] + b.get_data();

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> operator+(const nsl_num_0<NslNumType,NslTypeId>& a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
#ifdef NSL_DEBUG
	cout << "// nsl_num_1<NslNumType,NslTypeId>  operator+\n";
	cout << "// (data) " << a.get_name() << " + (vector) ";
	cout << b.get_name() << ";\n";
	cout.flush();
#endif

	int bimax = b.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(bimax);

	for (int i = 0; i < bimax; i++)
		c[i] = a.get_data() + b[i];

	return c;
}

// vector addition

template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLadd(const nsl_num_1<NslNumType,NslTypeId>& a)
{
	int aimax = a.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(aimax);

	for (int i = 0; i < aimax; i++)
		c[i] = a[i];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLadd(const nsl_num_1<NslNumType,NslTypeId>& a,const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int aimax = a.get_imax();
	int bimax = b.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(aimax);

	if (aimax != bimax)
	{
		cmd_error("*** nsl_num_1<NslNumType,NslTypeId>::NSLadd ***");
		cmd_error("Exit with status:");
		a.print_status(cerr);
		b.print_status(cerr);
		cmd_error("Inconsistent vector sizes");
		return c;
	}

	for (int i = 0; i < aimax; i++)
		c[i] = a[i] + b[i];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLadd(const nsl_num_1<NslNumType,NslTypeId>& a,const NslNumType b)
{
	int aimax = a.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(aimax);

	for (int i = 0; i < aimax; i++)
		c[i] = a[i] + b;

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLadd(const NslNumType a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int bimax = b.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(bimax);

	for (int i = 0; i < bimax; i++)
		c[i] = a + b[i];

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLadd(const nsl_num_1<NslNumType,NslTypeId>& a,const nsl_num_0<NslNumType,NslTypeId>& b)
{
	int aimax = a.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(aimax);

	for (int i = 0; i < aimax; i++)
		c[i] = a[i] + b.get_data();

	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLadd(const nsl_num_0<NslNumType,NslTypeId>& a, const nsl_num_1<NslNumType,NslTypeId>& b)
{
	int bimax = b.get_imax();

	nsl_num_1<NslNumType,NslTypeId> c(bimax);

	for (int i = 0; i < bimax; i++)
		c[i] = a.get_data() + b[i];

	return c;
}

// add equal

template<class NslNumType, int NslTypeId>
void NSLadd_equal(nsl_num_1<NslNumType,NslTypeId>& out,const nsl_num_1<NslNumType,NslTypeId>& a)
{
	int outmax = out.get_imax();

	for (int i = 0; i < outmax; i++)
		out[i] = a[i];
}
template<class NslNumType, int NslTypeId>
void NSLadd_equal(nsl_num_1<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a)
{
	int outmax = out.get_imax();

	for (int i = 0; i < outmax; i++)
		out[i] = a.get_data();
}

// mat_to_vec

template<class NslNumType, int NslTypeId>
void NSLadd_equal(nsl_num_1<NslNumType,NslTypeId>& out,const nsl_num_2<NslNumType,NslTypeId>& a)
{
	int vec_type = out.get_vec_type();

	int simax = a.get_imax();
	int sjmax = a.get_jmax();

	int s = out.get_imax();

	out = 0;
	
	if (vec_type == 0) // row vector
	{
	    for (int i = 0; i < simax; i++)
	    	for (int j = 0; j < sjmax; j++)
		    out[j] = out[j] + a[i][j];
	}
	if (vec_type == 1) // col vector
	{
	    for (int i = 0; i < simax; i++)
	    	for (int j = 0; j < sjmax; j++)
		    out[i] = out[i] + a[i][j];
	}
}

// add plus

template<class NslNumType, int NslTypeId>
void NSLadd_plus(nsl_num_1<NslNumType,NslTypeId>& out,const nsl_num_1<NslNumType,NslTypeId>& a)
{
	int outmax = out.get_imax();

	for (int i = 0; i < outmax; i++)
		out[i] = out[i] + a[i];
}
template<class NslNumType, int NslTypeId>
void NSLadd_plus(nsl_num_1<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a)
{
	int outmax = out.get_imax();

	for (int i = 0; i < outmax; i++)
		out[i] = out[i] + a.get_data();
}

// add minus

template<class NslNumType, int NslTypeId>
void NSLadd_minus(nsl_num_1<NslNumType,NslTypeId>& out,const nsl_num_1<NslNumType,NslTypeId>& a)
{
	int outmax = out.get_imax();

	for (int i = 0; i < outmax; i++)
		out[i] = out[i] - a[i];
}
template<class NslNumType, int NslTypeId>
void NSLadd_minus(nsl_num_1<NslNumType,NslTypeId>& out,const nsl_num_0<NslNumType,NslTypeId>& a)
{
	int outmax = out.get_imax();

	for (int i = 0; i < outmax; i++)
		out[i] = out[i] - a.get_data();
}

