/* SCCS  @(#)nsl_num_0<NslNumType,NslTypeId>_sat_library.h	1.2---95/08/14--16:08:57 */
/****************************************************************/
/*                                                           	*/
/*                  nsl_num_0<NslNumType,NslTypeId>_sat_library.h         */
/*                                                            	*/
/****************************************************************/
/*
extern nsl_num_0<NslNumType,NslTypeId> NSLsat(const nsl_num_0<NslNumType,NslTypeId>&);
extern nsl_num_0<NslNumType,NslTypeId> NSLsat(const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern nsl_num_0<NslNumType,NslTypeId> NSLsat(const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,
	const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
*/
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> NSLsat(const nsl_num_0<NslNumType,NslTypeId>& a)
{
	nsl_num_0<NslNumType,NslTypeId> c;
	if (a > 1.0)
		c = 1.0;
	else if (a > 0)
		c = a;
	else
		c = 0;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> NSLsat(const nsl_num_0<NslNumType,NslTypeId>& a,
	const NslNumType x1,const NslNumType x2)
{
	nsl_num_0<NslNumType,NslTypeId> c;
	if (a > x2)
		c = 1.0;
	else if (a > x1)
		c = (a-x1)/(x2-x1);
	else
		c = 0;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> NSLsat(const nsl_num_0<NslNumType,NslTypeId>& a,
	const nsl_num_0<NslNumType,NslTypeId>& x1,const nsl_num_0<NslNumType,NslTypeId>& x2)
{
	nsl_num_0<NslNumType,NslTypeId> c;
	if (a > x2)
		c = 1.0;
	else if (a > x1)
		c = (a-x1)/(x2-x1);
	else
		c = 0;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> NSLsat(const nsl_num_0<NslNumType,NslTypeId>& a,const NslNumType x1,
	const NslNumType x2,const NslNumType y1,const NslNumType y2)
{
	nsl_num_0<NslNumType,NslTypeId> c;
	if (a > x2)
	    c = y2;
	else if (a > x1)
	    c = (y2-y1)*(a-x1)/(x2-x1) + y1;
	else
	    c = y1;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_0<NslNumType,NslTypeId> NSLsat(const nsl_num_0<NslNumType,NslTypeId>& a,const nsl_num_0<NslNumType,NslTypeId>& x1,
	const nsl_num_0<NslNumType,NslTypeId>& x2,const nsl_num_0<NslNumType,NslTypeId>& y1,const nsl_num_0<NslNumType,NslTypeId>& y2)
{
	nsl_num_0<NslNumType,NslTypeId> c;
	if (a > x2)
	    c = y2;
	else if (a > x1)
	    c = (y2-y1)*(a-x1)/(x2-x1) + y1;
	else
	    c = y1;
	return c;
}
