/* SCCS  @(#)nsl_num_1<NslNumType,NslTypeId>_sat_library.h	1.2---95/08/14--16:08:57 */
/****************************************************************/
/*                                                           	*/
/*                  nsl_num_1<NslNumType,NslTypeId>_sat_library.h                    */
/*                                                            	*/
/****************************************************************/
/*
extern nsl_num_1<NslNumType,NslTypeId> NSLsat(const nsl_num_1<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> NSLsat(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> NSLsat(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> NSLsat(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&,
	const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> NSLsat(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_1<NslNumType,NslTypeId>&,
	const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> NSLsat(const nsl_num_1<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&,
	const nsl_num_0<NslNumType,NslTypeId>&,const nsl_num_0<NslNumType,NslTypeId>&);
extern nsl_num_1<NslNumType,NslTypeId> NSLsat(const nsl_num_1<NslNumType,NslTypeId>&,const NslNumType,const NslNumType,
       const NslNumType,const NslNumType);
*/

template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLsat(const nsl_num_1<NslNumType,NslTypeId>& a)
{
	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);

	for (int i = 0; i < s1; i++)
		if (a[i] > (NslNumType) 1)
			c[i] = (NslNumType) 1;
		else if (a[i] > 0)
			c[i] = a[i];
		else
			c[i] = 0;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLsat(const nsl_num_1<NslNumType,NslTypeId>& a,
	const nsl_num_1<NslNumType,NslTypeId>& x1,const nsl_num_1<NslNumType,NslTypeId>& x2)
{
	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);

	if (a.get_imax() != x1.get_imax() || a.get_imax() != x2.get_imax())
	{
		cmd_error("*** NSLsat ***");
		cmd_error("Exit with the following status");
		cmd_error("imax1: ",a.get_imax());
		cmd_error("imax2: ",x1.get_imax());
		cmd_error("imax3: ",x2.get_imax());
		cmd_error("bad vector sector");
		return c;
	}

	for (int i = 0; i < s1; i++)
		if (a[i] > x2[i])
			c[i] = (NslNumType) 1;
		else if (a[i] > x1[i])
			c[i] = (a[i]-x1[i])/(x2[i]-x1[i]);
		else
			c[i] = 0;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLsat(const nsl_num_1<NslNumType,NslTypeId>& a,
	const float x1,const float x2)
{
	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);

	for (int i = 0; i < s1; i++)
		if (a[i] > x2)
			c[i] = (NslNumType) 1;
		else if (a[i] > x1)
			c[i] = (a[i] - x1)/(x2 - x1);
		else
			c[i] = 0;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLsat(const nsl_num_1<NslNumType,NslTypeId>& a,
	const int x1,const int x2)
{
	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);

	for (int i = 0; i < s1; i++)
		if (a[i] > x2)
			c[i] = (NslNumType) 1;
		else if (a[i] > x1)
			c[i] = (a[i] - x1)/(x2 - x1);
		else
			c[i] = 0;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLsat(const nsl_num_1<NslNumType,NslTypeId>& a,
	const nsl_num_0<NslNumType,NslTypeId>& x1,const nsl_num_0<NslNumType,NslTypeId>& x2)
{
	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);

	for (int i = 0; i < s1; i++)
		if (a[i] > x2)
			c[i] = (NslNumType) 1;
		else if (a[i] > x1)
			c[i] = (a[i] - x1.get_data())/(x2.get_data() - x1.get_data());
		else
			c[i] = 0;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLsat(const nsl_num_1<NslNumType,NslTypeId>& a,
	const nsl_num_1<NslNumType,NslTypeId>& x1,const nsl_num_1<NslNumType,NslTypeId>& x2,
	const nsl_num_1<NslNumType,NslTypeId>& y1,const nsl_num_1<NslNumType,NslTypeId>& y2)
{
	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);

	if (a.get_imax() != x1.get_imax() ||  a.get_imax() != x2.get_imax() || 
	    a.get_imax() != y1.get_imax() ||  a.get_imax() != y2.get_imax())
	{
		cmd_error("*** NSLsat ***");
		cmd_error("Exit with the following status");
		cmd_error("imax1: ",a.get_imax());
		cmd_error("imax2: ",x1.get_imax());
		cmd_error("imax3: ",x2.get_imax());
		cmd_error("imax4: ",y1.get_imax());
		cmd_error("imax5: ",y2.get_imax());
		cmd_error("bad vector sector");
		return c;
	}

	for (int i = 0; i < s1; i++)
		if (a[i] > x2[i])
		    c[i] = y2[i];
		else if (a[i] > x1[i])
		    c[i] = (y2[i]-y1[i])*(a[i]-x1[i])/
				(x2[i]-x1[i]) + y1[i];
		else
		    c[i] = y1[i];
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLsat(const nsl_num_1<NslNumType,NslTypeId>& a,
	const nsl_num_1<NslNumType,NslTypeId>& x1,const nsl_num_1<NslNumType,NslTypeId>& x2,
	const NslNumType y1,const NslNumType y2)
{
	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);

	if (a.get_imax() != x1.get_imax() || a.get_imax() != x2.get_imax())
	{
		cmd_error("*** NSLsat ***");
		cmd_error("Exit with the following status");
		cmd_error("imax1: ",a.get_imax());
		cmd_error("imax2: ",x1.get_imax());
		cmd_error("imax3: ",x2.get_imax());
		cmd_error("bad vector sector");
		return c;
	}

	for (int i = 0; i < s1; i++)
		if (a[i] > x2[i])
		    c[i] = y2;
		else if (a[i] > x1[i])
		    c[i] = (y2-y1)*(a[i]-x1[i])/
				(x2[i]-x1[i]) + y1;
		else
		    c[i] = y1;
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLsat(const nsl_num_1<NslNumType,NslTypeId>& a,
	const nsl_num_1<NslNumType,NslTypeId>& x1,const nsl_num_1<NslNumType,NslTypeId>& x2,
	const nsl_num_0<NslNumType,NslTypeId>& y1,const nsl_num_0<NslNumType,NslTypeId>& y2)
{
	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);

	if (a.get_imax() != x1.get_imax() || a.get_imax() != x2.get_imax())
	{
		cmd_error("*** NSLsat ***");
		cmd_error("Exit with the following status");
		cmd_error("imax1: ",a.get_imax());
		cmd_error("imax2: ",x1.get_imax());
		cmd_error("imax3: ",x2.get_imax());
		cmd_error("bad vector sector");
		return c;
	}

	for (int i = 0; i < s1; i++)
		if (a[i] > x2[i])
		    c[i] = y2.get_data();
		else if (a[i] > x1[i])
		    c[i] = (y2.get_data()-y1.get_data())*(a[i]-x1[i])/
				(x2[i]-x1[i]) + y1.get_data();
		else
		    c[i] = y1.get_data();
	return c;
}
template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLsat(const nsl_num_1<NslNumType,NslTypeId>& a,
	const float x1,const float x2,
	const float y1,const float y2)
{
	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);

	for (int i = 0; i < s1; i++)
		if (a[i] > x2)
		    c[i] = y2;
		else if (a[i] > x1)
		    c[i] = (y2-y1)*(a[i]-x1)/(x2-x1) + y1;
		else
		    c[i] = y1;
	return c;
}

template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLsat(const nsl_num_1<NslNumType,NslTypeId>& a,
	const int x1,const int x2,
	const int y1,const int y2)
{
	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);

	for (int i = 0; i < s1; i++)
		if (a[i] > x2)
		    c[i] = (NslNumType) y2;
		else if (a[i] > x1)
		    c[i] = (NslNumType) (y2-y1)*(a[i]-x1)/(x2-x1) + y1;
		else
		    c[i] = (NslNumType) y1;
	return c;
}

template<class NslNumType, int NslTypeId>
nsl_num_1<NslNumType,NslTypeId> NSLsat(const nsl_num_1<NslNumType,NslTypeId>& a,
	const nsl_num_0<NslNumType,NslTypeId>& x1,const nsl_num_0<NslNumType,NslTypeId>& x2,
	const nsl_num_0<NslNumType,NslTypeId>& y1,const nsl_num_0<NslNumType,NslTypeId>& y2)
{
	int s1 = a.get_imax();
	nsl_num_1<NslNumType,NslTypeId> c(s1);

	for (int i = 0; i < s1; i++)
		if (a[i] > x2)
		    c[i] = y2.get_data();
		else if (a[i] > x1)
		    c[i] = (y2.get_data()-y1.get_data())*(a[i]-x1.get_data())/(x2.get_data()-x1.get_data()) + y1.get_data();
		else
		    c[i] = y1.get_data();
	return c;
}
