/* SCCS  @(#)nsl_num_4_sub_library.C	1.1---95/08/13--20:48:16 */
//
//	nsl_num_4_sub_library.C
//
/*
# include "nsl_all_kernel_include.h"

// num_4 subtruction

template<class NslNumType>
nsl_num_4<NslNumType> operator-(const nsl_num_4<NslNumType>& a)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_4 operator-\n";
        cout << "// (num_4) " << " = - (num_4) ";
        cout << a.get_name() << ";\n";
        cout.flush();
#endif

	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int akmax = a.get_kmax();
	int almax = a.get_lmax();

	nsl_num_4<NslNumType> c(aimax,ajmax,akmax,almax);

	for (int i = 0; i < aimax; i++)
		for (int j = 0; j < ajmax; j++)
			for (int k = 0; k < akmax; k++)
				for (int l = 0; l < almax; l++)
					c[i][j][k][l] = -a[i][j][k][l];

	return c;
}
template<class NslNumType>
nsl_num_4<NslNumType> operator-(const nsl_num_4<NslNumType>& a,const nsl_num_4<NslNumType>& b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_4 operator-\n";
        cout << "// (num_4) " << a.get_name() << " - (num_4) ";
        cout << b.get_name() << ";\n";
        cout.flush();
#endif

	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int akmax = a.get_kmax();
	int almax = a.get_lmax();
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();
	int bkmax = b.get_kmax();
	int blmax = b.get_lmax();

	nsl_num_4<NslNumType> c(aimax,ajmax,akmax,almax);

	if (aimax != bimax || ajmax != bjmax || akmax != bkmax || almax != blmax)
	{
		cmd_error("*** nsl_num_4::operator- ***");
		cmd_error("Exit with the following status");
		a.print_status(cerr);
		b.print_status(cerr);
		cmd_error("Inconsistent num_4 sizes");
		return c;
	}

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
			for (int k = 0; k < akmax; k++)
				for (int l = 0; l < almax; l++)
					c[i][j][k][l] = a[i][j][k][l] - b[i][j][k][l];

	return c;
}
template<class NslNumType>
nsl_num_4<NslNumType> operator-(const nsl_num_4<NslNumType>& a,const num_type b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_4 operator-\n";
        cout << "// (num_4) " << a.get_name() << " - (num_type) ";
        cout << b << ";\n";
        cout.flush();
#endif

	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int akmax = a.get_kmax();
	int almax = a.get_lmax();

	nsl_num_4<NslNumType> c(aimax,ajmax,akmax,almax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
			for (int k = 0; k < akmax; k++)
				for (int l = 0; l < almax; l++)
					c[i][j][k][l] = a[i][j][k][l] - b;

	return c;
}
template<class NslNumType>
nsl_num_4<NslNumType> operator-(const num_type a, const nsl_num_4<NslNumType>& b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_4 operator-\n";
        cout << "// (num_type) " << a << " - (num_4) ";
        cout << b.get_name() << ";\n";
        cout.flush();
#endif

	int bimax = b.get_imax();
	int bjmax = b.get_jmax();
	int bkmax = b.get_kmax();
	int blmax = b.get_lmax();

	nsl_num_4<NslNumType> c(bimax,bjmax,bkmax,blmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
			for (int k = 0; k < bkmax; k++)
				for (int l = 0; l < blmax; l++)
					c[i][j][k][l] = a - b[i][j][k][l];

	return c;
}
template<class NslNumType>
nsl_num_4<NslNumType> operator-(const nsl_num_4<NslNumType>& a,const nsl_num_0<NslNumType>& b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_4 operator-\n";
        cout << "// (num_4) " << a.get_name() << " - (data) ";
        cout << b.get_name() << ";\n";
        cout.flush();
#endif

	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int akmax = a.get_kmax();
	int almax = a.get_lmax();

	nsl_num_4<NslNumType> c(aimax,ajmax,akmax,almax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
			for (int k = 0; k < akmax; k++)
				for (int l = 0; l < almax; l++)
					c[i][j][k][l] = a[i][j][k][l] - b.get_data();

	return c;
}
template<class NslNumType>
nsl_num_4<NslNumType> operator-(const nsl_num_0<NslNumType>& a, const nsl_num_4<NslNumType>& b)
{
#ifdef NSL_DEBUG
        cout << "// nsl_num_4 operator-\n";
        cout << "// (data) " << a.get_name() << " - (num_4) ";
        cout << b.get_name() << ";\n";
        cout.flush();
#endif

	int bimax = b.get_imax();
	int bjmax = b.get_jmax();
	int bkmax = b.get_kmax();
	int blmax = b.get_lmax();

	nsl_num_4<NslNumType> c(bimax,bjmax,bkmax,blmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
			for (int k = 0; k < bkmax; k++)
				for (int l = 0; l < blmax; l++)
					c[i][j][k][l] = a.get_data() - b[i][j][k][l];

	return c;
}

// num_4 subtraction
template<class NslNumType>
nsl_num_4<NslNumType> NSLsub(const nsl_num_4<NslNumType>& a)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int akmax = a.get_kmax();
	int almax = a.get_lmax();

	nsl_num_4<NslNumType> c(aimax,ajmax,akmax,almax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
			for (int k = 0; k < akmax; k++)
				for (int l = 0; l < almax; l++)
					c[i][j][k][l] = -a[i][j][k][l];

	return c;
}
template<class NslNumType>
nsl_num_4<NslNumType> NSLsub(const nsl_num_4<NslNumType>& a,const nsl_num_4<NslNumType>& b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int akmax = a.get_kmax();
	int almax = a.get_lmax();
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();
	int bkmax = b.get_kmax();
	int blmax = b.get_lmax();

	nsl_num_4<NslNumType> c(aimax,ajmax,akmax,almax);

	if (aimax != bimax || ajmax != bjmax || akmax != bkmax || almax != blmax)
	{
		cmd_error("*** nsl_num_4::NSLsub ***");
		cmd_error("Exit with the following status");
		a.print_status(cerr);
		b.print_status(cerr);
		cmd_error("Inconsistent num_4 sizes");
		return c;
	}

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
			for (int k = 0; k < akmax; k++)
				for (int l = 0; l < almax; l++)
					c[i][j][k][l] = a[i][j][k][l] - b[i][j][k][l];

	return c;
}
template<class NslNumType>
nsl_num_4<NslNumType> NSLsub(const nsl_num_4<NslNumType>& a,const num_type b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int akmax = a.get_kmax();
	int almax = a.get_lmax();

	nsl_num_4<NslNumType> c(aimax,ajmax,akmax,almax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
			for (int k = 0; k < akmax; k++)
				for (int l = 0; l < almax; l++)
					c[i][j][k][l] = a[i][j][k][l] - b;

	return c;
}
template<class NslNumType>
nsl_num_4<NslNumType> NSLsub(const num_type a, const nsl_num_4<NslNumType>& b)
{
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();
	int bkmax = b.get_kmax();
	int blmax = b.get_lmax();

	nsl_num_4<NslNumType> c(bimax,bjmax,bkmax,blmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
			for (int k = 0; k < bkmax; k++)
				for (int l = 0; l < blmax; l++)
					c[i][j][k][l] = a - b[i][j][k][l];

	return c;
}
template<class NslNumType>
nsl_num_4<NslNumType> NSLsub(const nsl_num_4<NslNumType>& a,const nsl_num_0<NslNumType>& b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int akmax = a.get_kmax();
	int almax = a.get_lmax();

	nsl_num_4 c(aimax,ajmax,akmax,almax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
			for (int k = 0; k < akmax; k++)
				for (int l = 0; l < almax; l++)
					c[i][j][k][l] = a[i][j][k][l] - b.get_data();

	return c;
}
template<class NslNumType>
nsl_num_4<NslNumType> NSLsub(const nsl_num_0<NslNumType>& a,const  nsl_num_4<NslNumType>& b)
{
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();
	int bkmax = b.get_kmax();
	int blmax = b.get_lmax();

	nsl_num_4<NslNumType> c(bimax,bjmax,bkmax,blmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
			for (int k = 0; k < bkmax; k++)
				for (int l = 0; l < blmax; l++)
					c[i][j][k][l] = a.get_data() - b[i][j][k][l];

	return c;
}
*/
