/* SCCS  @(#)xnsl_tcltk_graph.C	1.1---95/08/13--21:05:31 */
//
//	xnsl_tcltk_graph.C
//
// cj 13/Oct/98
// Es necesario crear un contexto grafico (GC) en la PC con valores
// de omision para usar las funciones de Xlib. La mascara es
// un cero indicando que no hay cambio en ninguno de los 
// miembros de la estructura y el apuntador a los nuevos valores
// es nulo (pues no existen tales).
//			_gc = XCreateGC(_dpy, _xwin, 0, NULL);

# include "nsl_all_kernel_include.h"
# include "xnsl_all_xkernel_include.h"
# include "xnsl_tcltk_include.h"

extern int NSL_TK_FLUSH;
typedef char nsl_long_string[256];

int TK_DRAW = 0; // should be set to "0" for efficiency

xnsl_tcltk_graph::xnsl_tcltk_graph() : xnsl_tcltk_widget()
{
        set_type("graph");
        set_abstract_type("graph");
}
xnsl_tcltk_graph::~xnsl_tcltk_graph()
{
}
xnsl_widget* xnsl_tcltk_graph::make_widget()
{
	return new xnsl_tcltk_graph;
}

int xnsl_tcltk_graph::display()
{
	return 1;
}
int xnsl_tcltk_graph::xflush()
{
	if (NSL_TK_FLUSH == 1)
		Tcl_Eval(NSL_TCL_INTERP,"update idletasks");

	return 1;
}

int xnsl_tcltk_graph::clear_area(xnsl_widget* widget,int wx0,int wy0,int wx1,int wy1,int fg)
{
//	(wx0,wy0) is lower left corner.
//	 wx1: width, wy1: height

	nsl_long_string str;

	if (TK_DRAW == 1)
		fg = 1;

	if (fg == 1) {
		char c = ' '; // 'p';

		sprintf(str,"%s create rectangle %d%c %d%c %d%c %d%c -fill white -outline white",_wname,wx0,c,wy0,c,wx0+wx1-1,c,wy0+wy1-1,c);

		Tcl_Eval(NSL_TCL_INTERP,str);
	} 
	else 
	{
		sprintf(str,"%s",_wname); 

			_tkmain = ((xnsl_tcltk_widget*) widget)->get_tkmain(); // Tk_MainWindow(NSL_TCL_INTERP);

			if (_tkmain != NULL)
				_tkwin = ((xnsl_tcltk_widget*) widget)->get_tkwin(); // Tk_NameToWindow(NSL_TCL_INTERP,str,_tkmain);
			else
				cmd_error(" xnsl_tcltk_graph::draw_line NULL tkmain");

			if (_tkmain != NULL && _tkwin != NULL) 
			{
				_sc = ((xnsl_tcltk_widget*) widget)->get_screen(); // Tk_Screen(_tkwin);
				_scnum = ((xnsl_tcltk_widget*) widget)->get_screen_num(); // Tk_ScreenNumber(_tkwin);
				_dpy = ((xnsl_tcltk_widget*) widget)->get_display(); // Tk_Display(_tkwin);
				_white = ((xnsl_tcltk_widget*) widget)->get_white(); 
				_black = ((xnsl_tcltk_widget*) widget)->get_black(); 
				_xwin = Tk_WindowId(_tkwin);
				_gc = ((xnsl_tcltk_widget*) widget)->get_GC(); // DefaultGC(_dpy, DefaultScreen(_dpy));
			
				XSetForeground(_dpy,_gc,_white); // SET GC WHITE FOR DRAWING
				XFillRectangle(_dpy,_xwin,_gc,wx0,wy0,wx1,wy1);
//				XFillRectangle(_dpy,_pixmap,_gc,wx0,wy0,wx1,wy1);
			}
			else
				cmd_error(" xnsl_tcltk_graph::clear_area NULL tkwin");
	}
	
	return 1;
}
int xnsl_tcltk_graph::fill_rectangle(xnsl_widget* widget,int wx0,int wy0,int wx1,int wy1,
	int ni,int nj,int pos,int fg)
{
//	(wx0,wy0) is lower left corner.
//	 wx1: width, wy1: height

	if (TK_DRAW == 1)
		fg = 1;

	nsl_long_string str;

	if (fg == 1) {
		nsl_string pos_str;
		char c = ' '; // 'p';

		if (pos == 1)
			sprintf(pos_str," -fill black -outline black");
		else
			sprintf(pos_str," -fill white -outline black");

// at the moment we are deleting previous one
//		nsl_string istr;
//		sprintf(istr,"%s%d%d",_wname,ni,nj);
// avoid new rect creations by modifying existing one with itemconfigure, move, or ...
//		sprintf(str,"%s itemconfigure %s",_wname,istr);
//		sprintf(str,"%s delete %s",_wname,istr);
//		Tcl_Eval(NSL_TCL_INTERP,str);

// create new rectangles
//		sprintf(str,"%s create rectangle %d%c %d%c %d%c %d%c %s -tags %s",_wname,wx0,c,wy0,c,wx0+wx1,c,wy0+wy1,c,pos_str,istr);
		sprintf(str,"%s create rectangle %d%c %d%c %d%c %d%c %s",_wname,wx0,c,wy0,c,wx0+wx1,c,wy0+wy1,c,pos_str);

		Tcl_Eval(NSL_TCL_INTERP,str);

	} else {
			sprintf(str,"%s",_wname); 

			_tkmain = ((xnsl_tcltk_widget*) widget)->get_tkmain(); // Tk_MainWindow(NSL_TCL_INTERP);

			if (_tkmain != NULL)
				_tkwin = ((xnsl_tcltk_widget*) widget)->get_tkwin(); // Tk_NameToWindow(NSL_TCL_INTERP,str,_tkmain);
			else
				cmd_error(" xnsl_tcltk_graph::draw_line NULL tkmain");

			if (_tkmain != NULL && _tkwin != NULL) 
			{
				_sc = ((xnsl_tcltk_widget*) widget)->get_screen(); // Tk_Screen(_tkwin);
				_scnum = ((xnsl_tcltk_widget*) widget)->get_screen_num(); // Tk_ScreenNumber(_tkwin);
				_dpy = ((xnsl_tcltk_widget*) widget)->get_display(); // Tk_Display(_tkwin);
//				_xwin = ((xnsl_tcltk_widget*) widget)->get_window(); 
				_xwin = Tk_WindowId(_tkwin);
				_white = ((xnsl_tcltk_widget*) widget)->get_white(); 
				_black = ((xnsl_tcltk_widget*) widget)->get_black(); 
				_gc = ((xnsl_tcltk_widget*) widget)->get_GC(); // DefaultGC(_dpy, DefaultScreen(_dpy));
		
				XSetForeground(_dpy,_gc,_black); // SET GC BLACK FOR DRAWING
       			XFillRectangle(_dpy,_xwin,_gc,wx0,wy0,wx1,wy1);

				if (pos == -1) // -fill white -outline black
				{
					XSetForeground(_dpy,_gc,_white); // SET GC WHITE FOR DRAWING
					XFillRectangle(_dpy,_xwin,_gc,wx0+1,wy0+1,wx1-2,wy1-2);
				}

			}
			else
				cmd_error(" xnsl_tcltk_graph::fill_rectangle NULL tkwin");
	}

	return 1;
}
int xnsl_tcltk_graph::draw_line(xnsl_widget* widget,int wx0,int wy0,int wx1,int wy1,
	const char* color,int fg)
{
	nsl_string str;
	nsl_string line_color;

	sprintf(str,"%s",_wname); 

	if (TK_DRAW == 1)
		fg = 1;

	if (fg == 1)
	{
		char c = ' ';
		if (color != 0 && strcmp(color,"") != 0) // color != "" 
		{
			strcpy(line_color,color);
		}
		else
		{
			strcpy(line_color,"black");
		}

		sprintf(str,"%s create line %d%c %d%c %d%c %d%c -fill %s",
		    _wname,wx0,c,_height-wy0,c,wx1,c,_height-wy1,c,line_color);

		Tcl_Eval(NSL_TCL_INTERP,str);
	}
	else if (widget != NULL)
	{
			_tkmain = ((xnsl_tcltk_widget*) widget)->get_tkmain(); // Tk_MainWindow(NSL_TCL_INTERP);

			if (_tkmain != NULL)
				_tkwin = ((xnsl_tcltk_widget*) widget)->get_tkwin(); // Tk_NameToWindow(NSL_TCL_INTERP,str,_tkmain);
			else
				cmd_error(" xnsl_tcltk_graph::draw_line NULL tkmain");

			if (_tkmain != NULL && _tkwin != NULL) 
			{
				_sc = ((xnsl_tcltk_widget*) widget)->get_screen(); // Tk_Screen(_tkwin);
				_scnum = ((xnsl_tcltk_widget*) widget)->get_screen_num(); // Tk_ScreenNumber(_tkwin);
				_dpy = ((xnsl_tcltk_widget*) widget)->get_display(); // Tk_Display(_tkwin);
//				_xwin = ((xnsl_tcltk_widget*) widget)->get_window(); 
				_xwin = Tk_WindowId(_tkwin);
				_white = ((xnsl_tcltk_widget*) widget)->get_white(); 
				_black = ((xnsl_tcltk_widget*) widget)->get_black(); 
				_gc = ((xnsl_tcltk_widget*) widget)->get_GC(); 

				XSetForeground(_dpy,_gc,_black); 
				XDrawLine(_dpy,_xwin,_gc,wx0,_height-wy0,wx1,_height-wy1);
//				XDrawLine(_dpy,_pixmap,_gc,wx0,_height-wy0,wx1,_height-wy1);
			}
			else
				cmd_error(" xnsl_tcltk_graph::draw_line NULL tkwin");
	}
	else
		cmd_error(" xnsl_tcltk_graph::draw_line NULL widget");
	
	return 1;
}
int xnsl_tcltk_graph::draw_grid(xnsl_widget* widget,int wx0,int wy0,int wx1,int wy1,
	int wxs,int wys,num_type x0, num_type y0, num_type x1, num_type y1, 
	num_type xs, num_type ys,int fg)
{
	if (TK_DRAW == 1)
		fg = 1;

	if (fg == 1)
	{
		char c = ' '; // 'p';

		nsl_long_string str;
	
//	if (fg == 0) {
		sprintf(str,"gridArray %s %d %d %d %d %d %d",_wname,wx0,wy0,wx1,wy1,wxs,wys);
//	else // for single temporal graph
//		sprintf(str,"grid %s %d %d %d %d %f %f %f %f %f %f %c",
//			_wname,wx0,wy0,wx1,wy1,x0,y0,x1,y1,xs,ys,c);
//
		Tcl_Eval(NSL_TCL_INTERP,str);
	}
	else 
	{
		for (int x = wx0; x <= wx1; x += wxs)
   			draw_line(widget,x,wy0,x,wy1,"black",0); 
		for (int y = wy1; y >= wy0; y -= wys)
			draw_line(widget,wx0,y,wx1,y,"black",0); 
    }

	return 1;
}
int xnsl_tcltk_graph::draw_text(xnsl_widget* widget,int wx,int wy,const char* text)
{
	nsl_long_string str;
	char c = 'p';

	sprintf(str,"%s create text %d%c %d%c -text %s -anchor sw",_wname,wx,c,_height-wy,c,text);

	Tcl_Eval(NSL_TCL_INTERP,str);

	return 1;
}

xnsl_widget* xnsl_tcltk_graph::create_widget(const char *wname,
	xnsl_widget* pxnsl_widget,int x,int y,int w,int h,
	int,int,int,int,int,int,const char*,const char*)
{
	strcpy(_wname,wname);
	_X0 = x;
	_Y0 = y;
	_width = w;
	_height = h;

	return this;
}

int xnsl_tcltk_graph::print(ostream&) const
{
	return 1;
}


